var npBodyId = ""
var divElement =""

/*
 * OFD的ActiveX控件使用的js，负责加载和提供接口。
 * js压缩：http://tool.css-js.com/ 
 */
//通用对象
var OFD = {
    // 保存页面中所有的OCX实例
    _OCX_Array: [],
    // 使用id查找实例
    find: function (id) {
        var ocx = null;
        this._each(this._OCX_Array, function (i, e) {
            if (e._id === id) {
                ocx = e;
                return false;
            }
        });
        return ocx;
    },
    // 合并对象
    _extend: function (defs, target) {
        var r = target;
        if (this._isNull(r)) {
            if (this._isArray(defs)) {
                r = [];
            } else {
                r = {};
            }
        }
        this._each(defs, function (n, v) {
            if (!(n in r)) {
                r[n] = v;
            }
        });
        return r;
    },
    // 判断参数是否是数组
    _isArray: function (v) {
        return Object.prototype.toString.call(v) === "[object Array]";
    },
    // 判断是否为纯粹对象,like jquery.isPlainObject
    _isPlainObject: function (v) {
        // Must be an Object.
        // Because of IE, we also have to check the presence of the constructor
        // property.
        // Make sure that DOM nodes and window objects don't pass through, as
        // well
        if (!v || v.toString() !== "[object Object]" || v.nodeType
            || "setInterval" in v) {
            return false;
        }
        try {
            // Not own constructor property must be Object
            if (v.constructor && !v.hasOwnProperty("constructor")
                && !v.constructor.prototype.hasOwnProperty("isPrototypeOf")) {
                return false;
            }
        } catch (e) {
            // IE8,9 Will throw exceptions on certain host objects #9897
            return false;
        }
        // Own properties are enumerated firstly, so to speed up,
        // if last one is own, then all properties are own.
        var key;
        for (key in v) {
        }
        return key === undefined || v.hasOwnProperty(key);
    },
    // 判断参数是否是undefined或null
    _isNull: function (v) {
        return typeof v == "undefined" || (v != 0 && !v);
    },
    // 判断参数是有有效
    _isValid: function (v) {
        return this._isNull(v) !== true;
    },
    // getElementById
    _$: function (id) {
        return document.getElementById(id);
    },
    // createElement
    _new: function (tag) {
        return document.createElement(tag);
    },
    // for each like jquery
    _each: function (o, fn) {
        if (this._isArray(o)) {
            for (var i = 0, ol = o.length, val = o[0]; i < ol
            && fn.call(val, i, val) !== false; val = o[++i]) {
            }
        } else {
            for (var i in o) {
                if (fn.call(o[i], i, o[i]) === false) {
                    break;
                }
            }
        }
        return o;
    },
    // 一些页面方法
    Page: {
        // 获取窗口宽度
        width: function () {
            var w = 0;
            if (window.innerWidth) {
                w = window.innerWidth;
            } else if ((document.body) && (document.body.clientWidth)) {
                w = document.body.clientWidth;
            }
            // 通过深入Document内部对body进行检测，获取窗口大小
            if (document.documentElement
                && document.documentElement.clientHeight
                && document.documentElement.clientWidth) {
                w = document.documentElement.clientWidth;
            }
            return w;
        },
        // 获取窗口高度
        height: function () {
            var h = 0;
            if (window.innerHeight) {
                h = window.innerHeight;
            } else if ((document.body) && (document.body.clientHeight)) {
                h = document.body.clientHeight;
            }
            // 通过深入Document内部对body进行检测，获取窗口大小
            if (document.documentElement
                && document.documentElement.clientHeight
                && document.documentElement.clientWidth) {
                h = document.documentElement.clientHeight;
            }
            return h;
        },
        // 兼容FF和IE的事件，当e未定义的时候返回window.event
        dEvent: function (e) {
            if (!e) {
                return window.event;
            } else {
                return e;
            }
        }
    }
};

//OCX类型及方法
OFD.OCX = function (options) {
    // OCX的Object ID
    this._id;
    // 配置
    this.opts = OFD._extend({
        div: null,
        width: "100%",
        height: "100%",//2019.10.30 height: OFD.Page.height() + "px",

        loadMsg: "<span>正在加载控件，请稍候....</span>",
        // 控件安装程序的下载路径
        //downURL : "res/ocx/xReader.exe",
        // 是否检查控件已经安装װ
        checkInstalled: true
    }, options);
    // 控件对象
    this.ax;
    // 缓存用户操作.因为某些情况下,用户操作时,控件还没有初始化完毕
    this._optCache = {
        compsite: [],
        callback: [],
        convert: [],
        perform: [],
        svcaddr: [],
        savefile: [],
        closefile: [],
        open: [],
        enable: [],
        sealname: [],
        sealid: [],
        sealmethod: [],
        opts: {// 属性名称和方法的映射
            "compsite": "setCompositeVisible",
            "callback": "setCallback",
            "convert": "convertFile",
            "perform": "performClick",
            "svcaddr": "setServiceAddr",
            "open": "_open",
            "enable": "setCompsiteEnable",
            "savefile": "saveFile",
            "closefile": "closeFile",
            "sealname": "setSealName",
            "sealid": "setSealId",
            "sealmethod": "setSealSignMethod"
        }
    };

    // 加载控件
    this.load = function () {
        console.log("yozo:准备加载插件")
        var rand = this._randomString(10);
        var div = OFD._$(this.opts.div);
        console.log(this.opts.div)
        if (OFD._isNull(this.opts.div)) {
            div.innerHTML = "<span style='color:red;'>启动FireFox控件环境未准备好!</span>";
        }
        div.innerHTML = this.opts.loadMsg;
        this._id = "ofdReader_" + rand;
        npBodyId = this._id;
        OFD._OCX_Array.push(this); // 放入队列,以方便查找使用
        this._writeOCX();
        this.ready();
        console.log("yozo:---------------插件初始化完成------------------------")
        return this;
    };

    // 加载配置,完成准备工作,只执行一次
    this.ready = function () {
        console.log("yozo:加载配置，完成准备工作")
        if (this.ax) {// 已经初始化
            console.log("yozo:存在插件配置，退出配置程序")
            return this;
        }
        var o = OFD._$(this._id);
        if (!o)//|| !("openURL" in o)) 
        {
            var div = OFD._$(this.opts.div);
            div.innerHTML = "<span>ActiveX控件未正确初始化!</span>";
            return;
        }
        this.ax = o; // 赋值,很重要
        var _me = this;
        // 控制初始化时的组件显示
        var compsite = this.opts.compsite;

        if (compsite) {
            OFD._each(compsite, function (n, v) {
                console.log(n, v)
                _me.setCompositeVisible(n, v);
            });
        }

        // 加载完毕前的动作都执行一遍
        console.log("yozo:执行缓存动作")
        OFD._each(this._optCache, function (n, v) {
            if (OFD._isArray(v) && v.length > 0) {
                var fn = _me[_me._optCache.opts[n]];
                if (fn) {
                    OFD._each(v, function (i, e) {
                        var args = [];
                        OFD._each(e, function (ni, vi) {
                            args.push(vi);
                        });
                        try {
                            fn.apply(_me, args);
                        } catch (e) {
                        }
                    });
                }
                v.length = 0; // clear
            }
        });
        console.log("yozo:缓存动作执行完毕")
        return this;
    };

    // 内部函数请勿调用-生成随机串
    this._randomString = function (l) {
        var x = "0123456789qwertyuioplkjhgfdsazxcvbnm";
        var tmp = "";
        for (var i = 0; i < l; i++) {
            tmp += x.charAt(Math.ceil(Math.random() * 100000000) % x.length);
        }
        return tmp;
    };


    // 内部函数请勿调用-输出控件的html
    this._writeOCX = function () {
        console.log("yozo:创建插件所在标签embed，并且设置宽高及type")
        var w = this.opts.width;
        if (OFD._isNull(w) || w == "auto") {
            w = "100%";
        }
        var h = this.opts.height;
        if (OFD._isNull(h) || h == "auto") {
            h = "100%"; //2019.10.30 OFD.Page.height() + "px";
        }
        OFD._$(this.opts.div).innerHTML = "<embed id='" + this._id
            + "' width='" + w
            + "' height='" + h
            + "' type='application/x-reader' "
            + ">";
        console.log("yozo:embed标签创建完毕，加载插件完成")
    };

    // 内部函数请勿调用-检查组件是否准备完毕
    this._check = function () {
        return OFD._isValid(this.ax);
    };

    // 内部函数请勿调用-打开文件
    /*    this._open = function (type, path, name, bolread) {
            if (type == "file") {
                this.ax.openFile(path, bolread);
            }
            return true;
        };

    //以下为规范标准接口--wcs备注
        // 打开文件boolean openFile(in string strURL,in boolean readOnly);
        //strURL文件名，可以是本地文件，如“D:/files/xxxxx.ofd”；也可以是远程文件，如“http://localhost:88/files/xxxx.ofd”。
        this.openFile = function (path, bolread, ) {
            return this._open("file", path, name, bolread);
        };*/


    /**
     *  打开指定的本地或远程OFD或PDF文件。
     * @param filename  可以是本地文件路径、远程文件路径（http链接）
     * @param readOnly  是否以只读模式打开。true-只读，false-非只读。
     * @param strSaveUrl  远程保存地址。以只读模式打开时无效。
     */
    this.openFile = function (filename, readOnly, strSaveUrl){
        console.log("yozo:调用openFile接口，打开文件")
        var paramNum = arguments.length;
        if (this._check()) {
            var ox = this.ax;
            switch (paramNum){
                case 1:
                    var result = ox.openFile(filename);
                    console.log("yozo:调用openFile接口完成")
                    return result;
                case 2:
                    var result =  ox.openFile(filename, readOnly);
                    console.log("yozo:调用openFile接口完成")
                    return result;
                case 3:
                    var result =  ox.openFile(filename, readOnly, strSaveUrl);
                    console.log("yozo:调用openFile接口完成")
                    return result;
            }
        }

    };


    this.openFileDlg = function () {
        if (this._check()) {
            var ox = this.ax;
            ox.openFile();
        }
    }

    // 将加载或缓存的文件保存到本地磁盘boolean saveFile(in string strURL);
    //strURL保存的位置，可以是本地文件，如“D：/files/xxxxx.ofd”；也可以是远程文件，如“http://localhost:88/files/xxxx.ofd”。
    //2023.6.25 sc add//注意！使用nginx服务器时，client_max_body_size属性默认为1m，此时上传超过1m的文档到服务器时会接口会返回false，无法上传成功，请确保client_max_body_size属性值大于文档的内存大小。
    /**
     * 保存文件，该接口可按需 不传入参数，传入一个参数或传入三个参数方式调用
     * @param path (string) 保存的位置，可以是本地文件，如“D：/files/xxxxx.ofd”；也可以是远程文件，如“http://localhost:88/files/xxxx.ofd”。
     * @param isBase64 (bool)  是否以base64编码保存
     * @param saveFileName (string) 保存的文件名
     * @returns {*}
     */
    this.saveFile = function (path, isBase64, saveFileName) {
        var paramNum = arguments.length;
        switch (paramNum){
            case 0:
                if (this._check()) {
                    var ox = this.ax;
                    return ox.saveFile();
                }
            case 1:
                if (this._check()) {
                    console.log(path);
                    return this.ax.saveFile(path);
                } else {
                    this._optCache.savefile.push({ p: path });
                }
            case 3:
                if(this._check()){
                    var ox = this.ax;
                    return ox.saveFile(path, isBase64, saveFileName);
                }
                return '暂未实现';
        }
    };

    // 关闭当前文件
    this.closeFile = function () {
        if (this._check()) {
            this.ax.closeFile();
        } else {
            this._optCache.closefile.push({});
        }
        return true;
    };
    // 该接口与新接口重复
    //正常打印-void printFile(in string docName,in boolean bGray)直接打印文件，并按指定的打印任务名称和是否灰度打印设置执行
    this.printFile = function (title, color) {
        if (this._check()) {
            console.log("yozo:调用printFile接口" + "title:" + title + "   color:" + color)
            var ox = this.ax;
            //ox.PrintFile(title, color, 0);//htfoxit
            ox.printFile(title, color);//this 2019.10.28 add
            console.log("yozo:调用printFile接口完成")
        }
    }

    //静默打印
    this.quietPrintFile = function (title, color, isquietprint) {
        if (this._check()) {
            var ox = this.ax;
            ox.PrintFile(title, color, isquietprint);
        }
    }

    //打印Dlg
    this.openPrintDlg = function () {
        if (this._check()) {
            var ox = this.ax;
            ox.print();
        }
    }

    this.printSet = function (printParam) {
        if (this._check()) {
            console.log("yozo:调用printSet接口")
            var ox = this.ax;
            ox.configPrintOptions(printParam);
            console.log("yozo:调用printSet接口完成")
        }
    }

    //显示和隐藏组件setCompositeVisible(in string CompName,in boolean bEnable)界面元素的标识，见附录C
    this.setCompositeVisible = function (name, visible) {
        if (this._check()) {
            var o = this.ax;
            if (OFD._isArray(name)) {
                OFD._each(name, function (i, n) {
                    return o.setCompositeVisible(n, visible);
                });
            } else {
                return o.setCompositeVisible(name, visible);
            }
        } else {
            this._optCache.compsite.push(
                {
                    n: name,
                    v: visible
                });
        }
    };

    //启用/禁用组件setCompositeEnable(in string CompName,in boolean bEnable)界面元素的标识，见附录C
    this.setCompositeEnable = function (name, visible) {
        if (this._check()) {
            var o = this.ax;
            if (OFD._isArray(name)) {
                OFD._each(name, function (i, n) {
                    o.setCompositeEnable(n, visible);
                });
            } else {
                o.setCompositeEnable(name, visible);
            }
        } else {
            this._optCache.compsite.push(
                {
                    n: name,
                    v: visible
                });
        }
    };

    //设置视图首选项void setViewPreference(in string key,in string val);
    //key:"navigator"; val:"none/outline/thumbnail/semanteme", maybe bookmark/annotation/watermark
    this.setViewPreference = function (key, value) {
        if (this._check()) {
            var o = this.ax;
            o.setViewPreference(key, value);
        }
        //return this;
    };

    //设置页面显示比例void setZoomRadio(in float zoomValue);zoomValue  页面显示比例的值，例如：120表示120%。
    this.setZoomRadio = function (zoomvalue) {
        if (this._check()) {
            var ox = this.ax;
            ox.setZoomRadio(zoomvalue);
        }
    }

    //获取页面显示比例。返回值说明：页面显示比例值，例如：120表示120%
    this.getZoomRadio = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getZoomRadio();
        }
    }

    //设置当前的用户名（用于注释和操作日志)boolean setUserName(in string userName);
    this.setUserName = function (uname) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setUserName(uname);
        }
    }//设置印章标识void setSealId(in string sealId);--设置将要应用的印章标识。设置了此值后，将不能对当前文档应用与该标识不匹配的电子印章，此函数常用于配合用章授权。
    this.setSealId = function (uid) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setSealId(uid);
        }
    }

    //打印Dlg
    this.openSealDlg = function () {
        if (this._check()) {
            var ox = this.ax;
            ox.sign();
        }
    }

    //获取用户名
    this.getUserName = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getUserName();
        }

    }

    //增加文档元数据void setMetaData(in string id,in string val); id键见电子公文元数据标识，也可任意值
    this.setMetaData = function (key, value) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setMetaData(key, value);
        }
    }

    //获取文档元数据string getMetaData(in string id);
    this.getMetaData = function (key) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getMetaData(key);
        }
    }

    //设置日志服务地址void setLogSvrURL(in string url);--设置了日志服务地址后，写入日志文件的消息将同时按照标准HTTP协议写入日志服务。
    this.setLogSvrURL = function (url) {
        if (this._check()) {
            var ox = this.ax;
            ox.setLogSvrURL(url);
        }
    }

    //添加追踪水印void addTrackInfo(in string xmlParam);--水印信息将用于显示或打印文档。水印信息格式见附录E
    this.addTrackInfo = function (xmlParam) {
        if (this._check()) {
            var ox = this.ax;
            ox.addTrackInfo(xmlParam);
        }
        //return this;
    };

    //清除水印
    this.clearTrackInfo = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.clearTrackInfo();
        }
    }

    //获取公文域内容string getTaggedText(in string tagId);--从文档中获取指定名称的公文语义标引的内容
    //tagId--例如“电子公文/公文体/版头/密级”，见GB/T 33476.1-2016
    this.getTaggedText = function (docdomain) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getTaggedText(docdomain);
        }
    }

    //获取日志文件路径string getLogFilePath();此接口用于获取版式阅读软件日志文件路径，软件通过日志文件，将内部操作(如打印、签名、验签等)进行记录和汇报。
    //日志文件格式见附录F
    this.getLogFilePath = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getLogFilePath();
        }
    }
//以上为规范标准接口--wcs备注

    this.about = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.about();
        }
    }
    this.saveAs = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.saveAs();
        }
    }
    this.closeAllFiles = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.closeAllFiles();
        }
    }
    this.zoomIn = function () {
        if (this._check()) {
            var ox = this.ax;
            ox.zoomIn();
        }
    }
    this.zoomOut = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.zoomOut();
        }
    }
    this.selectAll = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.selectAll();
        }
    }
    this.getCurrentPageNum = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getCurrentPageNum();
        }
    }
    this.gotoFirstPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoFirstPage();
        }
    }
    this.gotoLastPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoLastPage();
        }
    }
    this.gotoPrevPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoPrevPage();
        }
    }
    this.gotoNextPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoNextPage();
        }
    }
    this.gotoPage = function (nPageNum) {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoPage(nPageNum);
        }
    }
    this.fitWidth = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.fitWidth();
        }
    }
    this.gotoLastPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoLastPage();
        }
    }
    this.fitPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.fitPage();
        }
    }
    this.navBarShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.navBarShowed();
        }
    }
    this.isToolBarShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isToolBarShowed();
        }
    }
    this.isFileToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isFileToolShowed();
        }
    }
    this.isZoomToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isZoomToolShowed();
        }
    }
    this.isZoomModeShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isZoomModeShowed();
        }
    }
    this.isPageToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isPageToolShowed();
        }
    }
    this.isSelectToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isSelectToolShowed();
        }
    }
    this.isSearchToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isSearchToolShowed();
        }
    }
    this.isSignAndWaterMrksToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isSignAndWaterMrksToolShowed();
        }
    }
    this.isAnnoToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isAnnoToolShowed();
        }
    }
    this.isPageLayoutShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isPageLayoutShowed();
        }
    }
    this.isRotateToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isRotateToolShowed();
        }
    }
    this.onOffNavBar = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffNavBar(bHide);
        }
    }
    this.onOffToolBar = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffToolBar(bHide);
        }
    }
    this.onOffFileTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffFileTool(bHide);
        }

    }
    this.onOffZoomTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffZoomTool(bHide);
        }
    }
    this.onOffZoomModeTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffZoomModeTool(bHide);
        }
    }
    this.onOffPageTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffPageTool(bHide);
        }
    }
    this.onOffSelectTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffSelectTool(bHide);
        }
    }
    this.onOffSearchTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffSearchTool(bHide);
        }
    }
    this.onOffSignAndWaterMrksTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffSignAndWaterMrksTool(bHide);
        }
    }
    this.onOffAnnoTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffAnnoTool(bHide);
        }
    }
    this.onOffPageLayout = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffPageLayout(bHide);
        }
    }
    this.onOffRotateTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffRotateTool(bHide);
        }
    }

    // 设置印章名称
    this.setSealName = function (path) {
        if (this._check()) {
            this.ax.setSealName(path);
        } else {
            this._optCache.setSealName.push({
                p: path
            });
        }
        return this;
    };

    // 设置签名算法
    this.setSealSignMethod = function (path) {
        if (this._check()) {
            this.ax.setSealSignMethod(path);
        } else {
            this._optCache.setSealSignMethod.push({
                p: path
            });
        }
        return this;
    };

    //
    this.setLogURL = function (strurl, oid) {
        if (this._check()) {
            var ox = this.ax;
            ox.setLogURL(strurl, oid);
        }
        return this;
    };

    this.HidePanels = function (nHide) {
        if (this._check()) {
            var ox = this.ax;
            //ox.HidePanels(parseInt(nHide));//htfoxit
            var bHide = Boolean(nHide);
            ox.onOffNavBar(bHide);//this 2019.10.28 add
        }
    }

    this.setPrintInfo = function (num) {
        if (this._check()) {
            var ox = this.ax;
            ox.setPrintInfo(parseInt(num));
        }
        return this;
    };


    //设置阅读模式--2019.10.29 waiting ....
    this.setDisPlayMode = function (disPlayMode) {
        if (this._check()) {
            var ox = this.ax;
            ox.setDisPlayMode(parseInt(disPlayMode));
        }
    }

    //设置显示宽度
    this.setZoomMode = function (zoomMode) {
        if (this._check()) {
            var ox = this.ax;
            //ox.setZoomMode(parseInt(zoomMode));//htfoxit
            //this 2019.10.28 add
            var val = parseInt(zoomMode);
            if(val==1) ox.fitPage();
            else if(val==2) ox.fitWidth();
            else if(val==0) ox.zoomReset();
            else if(val==3) ox.fitHeight();//2021.3.17 zs add
        }
    }

    //获取版本号
    this.getPluginVersion = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getPluginVersion();
        }
    }
    //注销
    this.destroyOCX = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.DestroyOCX();
        }
    }

    //获取公文域位置
    this.getTaggedPosition = function (docdomain) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getTaggedPosition(docdomain);
        }
    }

    //设置打开文档权限
    this.removeAppPermission = function (permission) {
        if (this._check()) {
            var ox = this.ax;
            return ox.removeAppPermission(permission);
        }
    }

    //判断是否正在打印
    this.IsQuietPrinting = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.IsQuietPrinting();
        }
    }

    //判断是否正在签章
    this.IsSigning = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.IsSigning();
        }
    }

    //静默打印设置
    this.printSetting = function () {
        if (this._check()) {
            var ox = this.ax;
            ox.printSetting();
        }
    }

    //本地保存
    this.saveToLocal = function (path) {
        if (this._check()) {
            var ox = this.ax;
            return ox.saveToLocal(path);
        }
    }

    //获取当前页的页码
    this.GetCurPageIndex = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getCurrentPageNum();//this 2019.10.28 add
        }
    }

    //获取当前文档页数
    this.getPageCount = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getPageCount();//2019.10.28 same
        }
    }
    //翻页
    this.GotoPage = function (index) {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoPage(parseInt(index));//this 2019.10.28 add
        }
    }

    //打开首页上半部分盖有多个印章的文档
    this.openSignFile = function (url) {
        if (this._check()) {
            var ox = this.ax;
            return ox.openSignFile(url);
        }
    }

    //获取签章个数
    this.CountSignatures = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.CountSignatures();
        }
    }

    //是否有签章
    this.hasSign = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.hasSign();
        }
    }

    //PDF导出OFD
    //[in]url:导出后ofd文件的目标位置,可以是本地文件，如“D：/files/xxxxx.ofd”；也可以是远程文件，如“http://localhost:8080/exm/Test1”。
    //[in]dpi:图像分辨率，默认96，范围[96,1200]
    //[out]导出成功返回true，失败返回false
    this.pdf2ofd = function (url, dpi) {
        if (this._check()) {
            var ox = this.ax;
            return ox.pdf2ofd(url, dpi);
        }
    }

    /**
     * pdf文件转成ofd文件
     * @param pszPdfUrl {string} PDF文件URL
     * @param PszOfdUrl {string} OFD文件URL
     * @param nBegin {int} 起始页码
     * @param nEnd {int} 结束页码
     * @param nResolution {int} 分辨率
     * @param nResv {int} 保留参数
     * @returns {*}
     */
    this.convertPdfToOfd = function (pszPdfUrl, PszOfdUrl, nBegin, nEnd, nResolution, nResv){
        if(this._check){
            var ox = this.ax;
            return ox.convertPdfToOfd(pszPdfUrl, PszOfdUrl, nBegin, nEnd, nResolution, nResv);
        }
    }

    //根据可配置参数执行模拟点击操作   注：该接口中可以是无参，也可以传入一个参数，也可以传入两个参数
    //[in]  commandId
    //[in]  params
    //[返回值] True/False
    this.performClick = function (a, b){
        var paramNum = arguments.length;
        console.log(paramNum)
        switch (paramNum){
            case 0:
                if(this._check){
                    var ox = this.ax;
                    return ox.performClick();
                }
            case 1:
                if(this._check){
                    var ox = this.ax;
                    return ox.performClick(a);
                }
            case 2:
                if(this._check){
                    var ox = this.ax;
                    return ox.performClick(a, b);
                }
        }
    }

    //设计签批笔触样式
    //[in] tabletFullsign
    //[返回值] 0
    this.setConfigInfo = function(configName, configValue){
        if(this._check){
            var ox = this.ax;
            return ox.setConfigInfo(configName, configValue);
        }
    }
    //设置签批笔记粗细
    //[in]  size
    //[返回值] true/false
    this.setSignSize = function(size){
        if(this._check){
            var ox = this.ax;
            return ox.setSignSize(size);
        }
    }
    //设置常用签批图片
    //[in]  strJson
    //[返回值] 无
    this.setCommonSigns = function(strJson){
        if(this._check){
            var ox = this.ax;
            return ox.setCommonSigns(strJson);
        }
    }
    //通过接口直接插入文本
    //[in]  strJson
    //[返回值] json
    this.addFreeText = function(strJson){
        if(this._check){
            var ox = this.ax;
            return ox.addFreeText(strJson);
        }
    }
    //设置文本批注默认字体
    //[in]  strJson
    //[返回值] 0
    this.setFreeTextDefaultFont = function(strJson){
        if(this._check){
            var ox = this.ax;
            return ox.setFreeTextDefaultFont(strJson);
        }
    }
    //获取文本信息
    //[in]  id
    //[返回值] json
    this.getFreeTextContentById = function(id){
        if(this._check){
            var ox = this.ax;
            return ox.getFreeTextContentById(id);
        }
    }
    //设置鼠标开关
    //[in]  bSwitch
    //[返回值] 无
    this.AnnotaTextTitleSwitch = function(bSwitch){
        if(this._check){
            var ox = this.ax;
            return ox.AnnotaTextTitleSwitch(bSwitch);
        }
    }
    //设置常用语
    //[in]  strJson
    //[返回值] 无
    this.SetFreqUserdComments = function(strjson){
        if(this._check){
            var ox = this.ax;
            return ox.SetFreqUserdComments(strjson);
        }
    }
    //设置签名图片
    //[in]  strJson
    //[返回值] 0
    this.SetSignatureImageByJson = function(strjson){
        if(this._check){
            var ox = this.ax;
            return ox.SetSignatureImageByJson(strjson);
        }
    }
    //设置文本批注鼠标提示信息
    //[in]  strJson
    //[返回值] 无
    this.SetAnnotaTextTitle = function(strjson){
        if(this._check){
            var ox = this.ax;
            return ox.SetAnnotaTextTitle(strjson);
        }
    }
    //设置当前时间格式
    //[in]  startTime
    //[返回值] 0
    this.setTimeFormat = function(startTime){
        if(this._check){
            var ox = this.ax;
            return ox.setTimeFormat(startTime);
        }
    }
    //删除指定范围得签批和图章
    //[in]  strJson
    //[返回值] 无
    this.deleteAnnotationByParameter = function(startTime){
        if(this._check){
            var ox = this.ax;
            return ox.deleteAnnotationByParameter(startTime);
        }
    }

    //清空
    //[返回值] true/false
    this.clearHandwrittenAnnotation = function(){
        if(this._check){
            var ox = this.ax;
            return ox.clearHandwrittenAnnotation();
        }
    }
    //设置环节控制参数
    //[in]  strJson
    //[返回值] 无
    this.SetStepsLimits = function(strJson){
        if(this._check){
            var ox = this.ax;
            return ox.SetStepsLimits(strJson);
        }
    }
    //直接在文件添加图章
    //[in]  annotInfo
    //[返回值] json
    this.addStampAnnot = function(annotInfo){
        if(this._check){
            var ox = this.ax;
            return ox.addStampAnnot(annotInfo);
        }
    }
    //添加跟随鼠标移动图章
    //[in]  annotInfo
    //[返回值] 无
    this.addMovingStamp = function(strJson){
        if(this._check){
            var ox = this.ax;
            return ox.addMovingStamp(strJson);
        }
    }
    //设置自定义图章
    //[in]  strUrls
    //[返回值] json
    this.addStampUrl = function(strUrls){
        if(this._check){
            var ox = this.ax;
            return ox.addStampUrl(strUrls);
        }
    }
    //根据用户ID、环节标识、注释类型、页码范围获取注释的信息
    //[in]  param
    //[返回值] json
    this.getAnnotInfoBy = function(param){
        if(this._check){
            var ox = this.ax;
            return ox.getAnnotInfoBy(param);
        }
    }
    //电子签章等比例拉伸设置
    //[in]  str
    //[返回值] 无
    this.SetNotDrawdragControl = function(str){
        if(this._check){
            var ox = this.ax;
            return ox.SetNotDrawdragControl(str);
        }
    }
    //电子签章默认缩放大小比例
    //[in]  bIsResize
    //[in]  Height
    //[in]  width
    //[返回值] 无
    this.SetKeepStampRatioParam = function(bIsResize, height, width){
        if(this._check){
            var ox = this.ax;
            return ox.SetKeepStampRatioParam(bIsResize, height, width);
        }
    }
    //设置添加人名章
    //[in]  strJson
    //[返回值] 无
    this.importSignatureImage = function(strJson){
        if(this._check){
            var ox = this.ax;
            return ox.importSignatureImage(strJson);
        }
    }

    //添加矩形块
    //[in]  strPos
    //[in]  r
    //[in]  g
    //[in]  b
    //[返回值] 无
    this.insertFillRect = function(strPos, r, g, b){
        if(this._check){
            var ox = this.ax;
            return ox.insertFillRect(strPos, r, g, b);
        }
    }

    //文件是否被编辑标识
    //[返回值] true/false
    this.IsDocomentHasChangedFlag = function(){
        if(this._check){
            var ox = this.ax;
            return ox.IsDocomentHasChangedFlag();
        }
    }
    //获取指定页的线段位置
    //[返回值] json
    this.GetLinePos = function(){
        if(this._check){
            var ox = this.ax;
            return ox.GetLinePos();
        }
    }
    //保存签批内容扩展
    //[in]  strURL
    //[返回值] Success/Error
    this.saveFileRetResult = function(strURL){
        if(this._check){
            var ox = this.ax;
            return ox.saveFileRetResult(strURL);
        }
    }

    /**
     * 合并文件
     * @param strJson {json} JSON格式的文件信息
     * @returns {*} 0
     */
    this.mergeFiles = function(strJson){
        if(this._check){
            var ox = this.ax;
            return ox.mergeFiles(strJson);
        }
    }
    //跳到指定页
    //[in]  nPage
    //[返回值] 0
    this.turnToPage = function(nPage){
        if(this._check){
            var ox = this.ax;
            return ox.turnToPage(nPage);
        }
    }

    //设置即将打开文档禁止操作权限
    //[in]  strJson
    //[返回值] 无
    this.setUserAnnotPermission = function(strJson){
        if(this._check){
            var ox = this.ax;
            return ox.setUserAnnotPermission(strJson);
        }
    }
    //设置配置信息
    //[in]  strUserID
    //[返回值] true/false
    this.setUserId = function(strUserID){
        if(this._check){
            var ox = this.ax;
            return ox.setUserId(strUserID);
        }
    }
    //设置用户名
    //[in]  strUserName
    //[返回值] true/false
    this.setUserName = function(strUserName){
        if(this._check){
            var ox = this.ax;
            return ox.setUserName(strUserName);
        }
    }
    //获取保存的临时配置项值
    //[in]  str
    //[返回值] 获取到的本地保存的临时配置项的值
    this.GetConfigInfo = function(str){
        if(this._check){
            var ox = this.ax;
            return ox.GetConfigInfo(str);
        }
    }
    //获取阅读器版本
    //[返回值] 对应版本号
    this.version = function(){
        if(this._check){
            var ox = this.ax;
            return ox.version();
        }
    }
    //获取阅读器版本
    //[返回值] 对应版本号
    this.getAppVersion = function(){
        if(this._check){
            var ox = this.ax;
            return ox.getAppVersion();
        }
    }
    // 获取当前进程PID。
    this.GetCurrentAppPID = function(){
        if(this._check){
            var ox = this.ax;
            return ox.GetCurrentAppPID();
        }
    }
    //获取全文文本内容
    //[out] 将全文文本内容输出
    this.exportText = function(){
        if(this._check){
            var ox = this.ax;
            return ox.exportText();
        }
    }
//设置全屏显示

    this.readerFullScreen = function (){
        if(this._check){
            var ox = this.ax;
            return ox.readerFullScreen();
        }
    }
    //打开添加文号章界面
    this.AddChapter = function(){
        if(this._check){
            var ox = this.ax;
            return ox.AddChapter();
        }
    }

    this.addImageStamp = function (a){
        var paramNum = arguments.length;
        switch (paramNum){
            case 0:
                if(this._check){
                    var ox = this.ax;
                    return ox.addImageStamp();
                }
            case 1:
                if(this._check){
                    var ox = this.ax;
                    return ox.addImageStamp(a);
                }
        }
    }
    //将已打开的文件保存为base64
    this.saveBase64File = function(){
        if(this._check){
            var ox = this.ax;
            return ox.saveBase64File();
        }
    }
    //保存页面内容为base64内容流
    // [in] strPageindex 待保存为base64内容流的页面范围，相邻页面中间用'-'，隔开，不相邻页面用','隔开，例如1-3
    // 输出为转换成功的base64内容流
    this.saveBase64FilebyIndex = function(strPageIndex){
        if(this._check){
            var ox = this.ax;
            return ox.saveBase64FilebyIndex(strPageIndex);
        }
    }
    //打开base64文件流的文件
    //[in] stream base64格式文件流
    //[out] 打开成功返回true，打开失败返false
    this.openBase64File = function(stream){
        if(this._check){
            var ox = this.ax;
            return ox.openBase64File(stream);
        }
    }
    //[out]成功返回交号章id号
    this.AddChapterByIDAndUrl = function(strJson){
        if(this._check){
            var ox = this.ax;
            return ox.AddChapterByIDAndUrl(strJson);
        }
    }

    //2023.12.26 mlj add--------------------------------------------------补充接口
    //打开当前打开文档属性（元数据）对话框
    this.on_propsAct_triggered = function(){
        if(this._check){
            var ox = this.ax;
            return ox.on_propsAct_triggered();
        }
    }
    //设置密级标志信息。
    //[in]strMBInfo，string，密级标识信息Json字符串
    this.setMBInfo = function(strMBInfo){
        if(this._check){
            var ox = this.ax;
            return ox.setMBInfo(strMBInfo);
        }
    }
    //重置缩放比
    this.zoomReset = function(){
        if(this._check){
            var ox = this.ax;
            return ox.zoomReset();
        }
    }
    //打开当前打开文档元数据对话框。可进行元数据设置、权限修改等。
    this.getMetaDataWindow = function(){
        if(this._check){
            var ox = this.ax;
            return ox.getMetaDataWindow();
        }
    }

    this.getUserId = function(){
        if(this._check){
            var ox = this.ax;
            return ox.getUserId();
        }
    }
    //  设置文本批注时，字体下拉框内的可选字体。
    this.SetFreeTextFontsGather = function(strFonts){
        if(this._check){
            var ox = this.ax;
            return ox.SetFreeTextFontsGather(strFonts);
        }
    }
    // 在文本批注字体集合中添加字体
    this.AddFreeTextFontsGather = function(strFonts){
        if(this._check){
            var ox = this.ax;
            return ox.AddFreeTextFontsGather(strFonts);
        }
    }
    //  在文本批注字体集合中删除字体
    this.SubFilterFontsGather = function(strFonts){
        if(this._check){
            var ox = this.ax;
            return ox.SubFilterFontsGather(strFonts);
        }
    }
    //2024.1.11 mlj add 补充接口
    this.onOffMenuBarPermanently = function(bHide){
        if(this._check){
            var ox = this.ax;
            return ox.onOffMenuBarPermanently(bHide);
        }
    }
    this.onOffToolMenuPermanently = function(strToolName, bHide){
        if(this._check){
            var ox = this.ax;
            return ox.onOffToolMenuPermanently(strToolName, bHide);
        }
    }





//start 2024.1.11 mlj 增加暂未实现接口------------------------------------------------------------------
    //右键菜单接口
    this.onOffRightClick = function(bhide){
        if(this._check){
            var ox = this.ax;
            return ox.onOffRightClick(bhide);
        }
    }
    //打开最近的文件
    this.openRecentFile = function(){
        if(this._check){
            var ox = this.ax;
            return ox.openRecentFile();
        }
    }
    /**
     * 离线保存文件
     * @param strsrc {string} 源文件
     * @param strDst {string} 目标文件
     * @param noGray {bool} 是否灰度
     * @param strtmpName {string} 临时文件名
     * @returns {*}
     */
    this.savefileOffSystem = function(strsrc, strDst, noGray, strtmpName){
        if(this._check){
            var ox = this.ax;
            return ox.savefileOffSystem(strsrc, strDst, noGray, strtmpName);
        }
    }
    /**
     * 提取页面
     * @param pageRange {string} 页面范围
     * @param outputPath {string} 输出路径
     * @returns {*}
     */
    this.extractPage = function(pageRange, outputPath){
        if(this._check){
            var ox = this.ax;
            return ox.extractPage(pageRange, outputPath);
        }
    }
    /**
     * 合并文件
     * @param filePath {string} 文件路径
     * @param insertIndex {int} 插入索引
     * @param deleteAfterMerge {bool} 合并后是否删除原文件
     * @returns {*}
     */
    this.mergeFile = function(filePath, insertIndex, deleteAfterMerge){
        if(this._check){
            var ox = this.ax;
            return ox.mergeFile(filePath, insertIndex, deleteAfterMerge);
        }
    }
    /**
     * 导出附件
     * @param strFilePath {string} 导出文件路径
     * @param showMessage {bool} 是否显示消息
     * @returns {*}
     */
    this.exportAttachment = function(strFilePath, showMessage){
        if(this._check){
            var ox = this.ax;
            return ox.exportAttachment(strFilePath, showMessage);
        }
    }
    /**
     * 从 base64 pdf 文件转换到指定路径 ofd 文件并返回文件 base64 数据流信息
     * @param base64Info {string} base64 格式的 pdf 文件信息
     * @param destFile {bool} 目标文件路径
     * @returns {*} 文件 base64 数据流信息
     */
    this.convertFileFromBase64PDF = function(base64Info, destFile){
        if(this._check){
            var ox = this.ax;
            return ox.convertFileFromBase64PDF(base64Info, destFile);
        }
    }
    /**
     * 获取文件的 MD5 哈希值
     * @returns {*}
     */
    this.getFileMd5Value = function(){
        if(this._check){
            var ox = this.ax;
            return ox.getFileMd5Value();
        }
    }
    /**
     * 打开接续文档
     * @param fileInfo {string} 文件信息
     * @returns {*}
     */
    this.openContinuousFile = function(fileInfo){
        if(this._check){
            var ox = this.ax;
            return ox.openContinuousFile(fileInfo);
        }
    }
    /**
     * 检查是否可打开
     * @param filename {string} 文件名
     * @returns {*}
     */
    this.checkOpenable = function(filename){
        if(this._check){
            var ox = this.ax;
            return ox.checkOpenable(filename);
        }
    }
    /**
     * 解密所有印章为灰度
     * @param saveFileName
     * @returns {*}
     */
    this.decryptAlltoGray = function(saveFileName){
        if(this._check){
            var ox = this.ax;
            return ox.decryptAlltoGray(saveFileName);
        }
    }
    /**
     * 取消编写日期文本
     * @returns {*}
     */
    this.cancelWriteDateText = function(){
        if(this._check){
            var ox = this.ax;
            return ox.cancelWriteDateText();
        }
    }
    /**
     * 设置窗口句柄
     * @param hwnd
     * @returns {*}
     */
    this.setWindowHandle = function(hwnd){
        if(this._check){
            var ox = this.ax;
            return ox.setWindowHandle(hwnd);
        }
    }
    /**
     * 获取用户临时目录
     * @returns {*}
     */
    this.getUserTempDir = function(){
        if(this._check){
            var ox = this.ax;
            return ox.getUserTempDir();
        }
    }
//2024.1.12 mlj add 增加接口
    /**
     * 删除文件
     * @param filepath {string} 文件路径
     * @returns {*}
     */
    this.deleteFileByPath = function(filepath){
        if(this._check){
            var ox = this.ax;
            return ox.deleteFileByPath(filepath);
        }
    }
    /**
     * 将文件复制到目标路径
     * @param srcpath
     * @param destpath
     * @returns {*}
     */
    this.copyFileToDestination = function(srcpath, destpath){
        if(this._check){
            var ox = this.ax;
            return ox.copyFileToDestination(srcpath, destpath);
        }
    }
    /**
     * 设置扫描配置信息
     * @param scanInfo {string}
     * @returns {*}
     */
    this.setScanConfigInfo = function(scanInfo){
        if(this._check){
            var ox = this.ax;
            return ox.setScanConfigInfo(scanInfo);
        }
    }
    /**
     * 获取重复信息
     * @param info {string}
     * @returns {*}
     */
    this.getDuplicteInfo = function(info){
        if(this._check){
            var ox = this.ax;
            return ox.getDuplicteInfo(info);
        }
    }
    /**
     * 添加待删除文件
     * @param fileName {string} 文件名
     * @returns {*}
     */
    this.addFileToDelete = function(fileName){
        if(this._check){
            var ox = this.ax;
            return ox.addFileToDelete(info);
        }
    }
    /**
     * 保存安全文件
     * @param jsoninfo {json} json格式文件信息
     * @returns {*}
     */
    this.saveEnvFile = function(jsoninfo){
        if(this._check){
            var ox = this.ax;
            return ox.saveEnvFile(jsoninfo);
        }
    }
    /**
     * 打开安全ofd文件
     * @param filename {string} 文件名
     * @param strEncryptionInfoPath {stroing} 加密信息路径
     * @returns {*}
     */
    this.openEnvFile = function(filename, strEncryptionInfoPath){
        if(this._check){
            var ox = this.ax;
            return ox.openEnvFile(filename, strEncryptionInfoPath);
        }
    }
    /**
     * 从图片创建ofd文件
     * @param params {string}
     * @returns {*}
     */
    this.createOFDfromImages = function(params){
        if(this._check){
            var ox = this.ax;
            return ox.createOFDfromImages(params);
        }
    }
    /**
     * 导出PDF文件
     * @param path {string} 导出路径
     * @param range {string} 范围
     * @returns {*}
     */
    this.ExportPdfFile = function(path, range){
        if(this._check){
            var ox = this.ax;
            return ox.ExportPdfFile(path, range);
        }
    }
    /**
     * 异步下载接口
     * @param url {string} 下载地址
     * @param localFileName {string} 本地文件名
     * @param md5 {string} MD5值
     * @returns {*}
     */
    this.downloadHttpFile = function(url, localFileName, md5){
        if(this._check){
            var ox = this.ax;
            return ox.downloadHttpFile(url, localFileName, md5);
        }
    }
    /**
     * 删除本地文件接口
     * @param localFileName {string}
     * @returns {*}
     */
    this.deleteLocalFile = function(localFileName){
        if(this._check){
            var ox = this.ax;
            return ox.deleteLocalFile(localFileName);
        }
    }
    /**
     * 上传本地文件接口
     * @param url {string} 上传地址
     * @param localFileName {string} 本地文件名
     * @returns {*}
     */
    this.uploadLocalFile = function(url, localFileName){
        if(this._check){
            var ox = this.ax;
            return ox.uploadLocalFile(url, localFileName);
        }
    }
    /**
     * 获取计算机名
     * @returns {*}
     */
    this.getLocalHostName = function(){
        if(this._check){
            var ox = this.ax;
            return ox.getLocalHostName();
        }
    }
    /**
     * 删除本地目录
     * @param url {string} 目录路径
     * @returns {*}
     */
    this.deleteLocalDir = function(url){
        if(this._check){
            var ox = this.ax;
            return ox.deleteLocalDir(url);
        }
    }
    /**
     * 修改本地目录
     * @param url {string} 目录路径
     * @param localDirName {string} 新目录名
     * @returns {*}
     */
    this.renameLocalDir = function(url, localDirName){
        if(this._check){
            var ox = this.ax;
            return ox.renameLocalDir(url, localDirName);
        }
    }
    /**
     * 判断是否为ofd文件,是否转换为txt
     * @param params {string}
     * @returns {*}
     * @constructor
     */
    this.IsOfdFileConvertTxt = function(params){
        if(this._check){
            var ox = this.ax;
            return ox.IsOfdFileConvertTxt(params);
        }
    }
    /**
     * 提取页面为txt文件
     * @param distillInfo {string} 提取信息
     * @returns {*}
     * @constructor
     */
    this.DistillPageAsTxt = function(distillInfo){
        if(this._check){
            var ox = this.ax;
            return ox.DistillPageAsTxt(distillInfo);
        }
    }
    /**
     * 下载安全文件
     * @param filename {string}
     * @param param {string}
     * @returns {*}
     */
    this.downloadFile = function(filename, param){
        if(this._check){
            var ox = this.ax;
            return ox.downloadFile(filename, param);
        }
    }
    /**
     * 转换文件
     * @returns {*}
     * @param srcpath {string} 源文件路径
     * @param destFile {string} 目标文件
     * @param metaContent {string} 元数据内容
     */
    this.convertFile = function(srcpath, destFile, metaContent){
        if(this._check){
            var ox = this.ax;
            return ox.convertFile(srcpath, destFile, metaContent);
        }
    }
    /**
     * 插入base64数据流文件
     * @param base64Info {string}
     * @returns {*}
     * @constructor
     */
    this.InsertBase64File = function(base64Info){
        if(this._check){
            var ox = this.ax;
            return ox.InsertBase64File(base64Info);
        }
    }
    /**
     * 合并Base64数据
     * @param base64Data {string} Base64数据
     * @param insertIndex {int} 插入索引
     * @param deleteAfterMerge {bool} 合并后是否删除原数据
     * @returns {*}
     */
    this.mergeBase64 = function(base64Data, insertIndex, deleteAfterMerge){
        if(this._check){
            var ox = this.ax;
            return ox.mergeBase64(base64Data, insertIndex, deleteAfterMerge);
        }
    }
    /**
     * 拆分OFD文件
     * @param distillInfo {string}
     * @returns {*}
     * @constructor
     */
    this.DistillOFD = function(distillInfo){
        if(this._check){
            var ox = this.ax;
            return ox.DistillOFD(distillInfo);
        }
    }
    /**
     * 合并OFD文件
     * @param distillInfo {string}
     * @returns {*}
     * @constructor
     */
    this.MergeOFD = function(distillInfo){
        if(this._check){
            var ox = this.ax;
            return ox.MergeOFD(distillInfo);
        }
    }
    /**
     * 页面旋转
     * @param rotateInfo {string}
     * @returns {*}
     */
    this.setPageRotateByInfo = function(rotateInfo){
        if(this._check){
            var ox = this.ax;
            return ox.setPageRotateByInfo(rotateInfo);
        }
    }
    /**
     * 自动翻页
     * @param state {string} 状态
     * @returns {*}
     */
    this.setAutoTurnPagesState = function(state){
        if(this._check){
            var ox = this.ax;
            return ox.setAutoTurnPagesState(state);
        }
    }
    /**
     * 获取文件指定页面宽度
     * @param pageIndex {int}
     * @returns {*}
     */
    this.getPageWidth = function(pageIndex){
        if(this._check){
            var ox = this.ax;
            return ox.getPageWidth(pageIndex);
        }
    }
    /**
     * 获取文件指定页面高度
     * @param pageIndex {int}
     * @returns {*}
     */
    this.getPageHeight = function(pageIndex){
        if(this._check){
            var ox = this.ax;
            return ox.getPageHeight(pageIndex);
        }
    }
    /**
     * 跳转到指定区域
     * @param viewInfo {string}
     * @returns {*}
     */
    this.gotoDestArea = function(viewInfo){
        if(this._check){
            var ox = this.ax;
            return ox.gotoDestArea(pageIndex);
        }
    }
    /**
     * 设置视图缩放率
     * @param scale {float}
     * @returns {*}
     */
    this.setScale = function(scale){
        if(this._check){
            var ox = this.ax;
            return ox.setScale(scale);
        }
    }
    /**
     * 设置多文档模式
     * @param mode {boolean}
     * @returns {*}
     */
    this.setSingleMode = function(mode){
        if(this._check){
            var ox = this.ax;
            return ox.setSingleMode(mode);
        }
    }
    /**
     * 获取当前是否单文档模式
     * @returns {*}
     */
    this.isSingleMode = function(){
        if(this._check){
            var ox = this.ax;
            return ox.isSingleMode();
        }
    }
    /**
     * 获取页面文本
     * @param pageIndex {int} 页面索引
     * @param includeHiddenContent {boolean} 是否包含隐藏内容
     * @returns {*}
     */
    this.getPageTxt = function(pageIndex, includeHiddenContent){
        if(this._check){
            var ox = this.ax;
            return ox.getPageTxt(pageIndex, includeHiddenContent);
        }
    }
    /**
     * 获取页面图像数据
     * @param pageIndex {int}
     * @param dpi {int}
     * @param format {string}
     * @returns {*}
     */
    this.getPageImgData = function(pageIndex, dpi, format){
        if(this._check){
            var ox = this.ax;
            return ox.getPageImgData(pageIndex, dpi, format);
        }
    }
    /**
     * 设置插件的前景
     * @param config {string}
     * @returns {*}
     */
    this.setForeGroundInfo = function(config){
        if(this._check){
            var ox = this.ax;
            return ox.setForeGroundInfo(config);
        }
    }
    /**
     * 获取页面视图
     * @param pageIndex {int} 页面索引
     * @param left {int} 视图左上角横坐标
     * @param top {int} 视图左上角纵坐标
     * @returns {*}
     */
    this.getPageView = function(pageIndex, left, top){
        if(this._check){
            var ox = this.ax;
            return ox.getPageView(pageIndex, left, top);
        }
    }
    /**
     * 设置插件的背景
     * @param config {string}
     * @returns {*}
     */
    this.setBackGroundInfo = function(config){
        if(this._check){
            var ox = this.ax;
            return ox.setBackGroundInfo(config);
        }
    }
    /**
     * 执行拷贝
     * @returns {*}
     */
    this.editCopy = function(){
        if(this._check){
            var ox = this.ax;
            return ox.editCopy();
        }
    }
    /**
     * 执行粘贴
     * @returns {*}
     */
    this.editPaste = function(){
        if(this._check){
            var ox = this.ax;
            return ox.editPaste();
        }
    }
    /**
     * IrisMark
     * 执行跳转
     * @param pageIndex {int}
     * @param xpost {int}
     * @param ypost {int}
     * @returns {*}
     */
    this.gotoDest = function(pageIndex, xpost, ypost){
        if(this._check){
            var ox = this.ax;
            return ox.gotoDest(pageIndex, xpost, ypost);
        }
    }
    /**
     * 执行操作
     * @param commandXML {string}
     * @returns {*}
     */
    this.excuteOperation = function(commandXML){
        if(this._check){
            var ox = this.ax;
            return ox.excuteOperation(commandXML);
        }
    }
    /**
     * 插入空白页
     * @param info {string}
     * @returns {*}
     */
    this.insertBlankPage = function(info){
        if(this._check){
            var ox = this.ax;
            return ox.insertBlankPage(info);
        }
    }
    /**
     * 删除页面
     * @param pageIndex
     * @returns {*}
     */
    this.deletePage = function(pageIndex){
        if(this._check){
            var ox = this.ax;
            return ox.deletePage(pageIndex);
        }
    }
    /**
     * 自定义文本框落款
     * @param signinfo {string}
     * @returns {*}
     */
    this.setCommentsSignInfo = function(signinfo){
        if(this._check){
            var ox = this.ax;
            return ox.setCommentsSignInfo(signinfo);
        }
    }
    /**
     * 导航栏切换
     * @returns {*}
     */
    this.navbarSwitch = function(){
        if(this._check){
            var ox = this.ax;
            return ox.navbarSwitch();
        }
    }
    /**
     * 导航栏是否显示
     * @returns {*}
     */
    this.navBarShowed = function(){
        if(this._check){
            var ox = this.ax;
            return ox.navBarShowed();
        }
    }
    /**
     * 显示/隐藏导航栏
     * @param obj {boolean}
     * @param visible {boolean}
     * @returns {*}
     */
    this.setNavigatorVisible = function(obj, visible){
        if(this._check){
            var ox = this.ax;
            return ox.setNavigatorVisible(obj, visible);
        }
    }
    /**
     * 设置导航栏不能移动
     * @param value {boolean}
     * @returns {*}
     */
    this.setToolbarMovable = function(value){
        if(this._check){
            var ox = this.ax;
            return ox.setToolbarMovable(value);
        }
    }
    /**
     * 获取工具栏是否可移动
     * @param compName {string}
     * @returns {*}
     */
    this.getToolbarMovable = function(compName){
        if(this._check){
            var ox = this.ax;
            return ox.getToolbarMovable(compName);
        }
    }
    /**
     * 检查文档所有页面是否为图像
     * @returns {*}
     */
    this.checkDocAllPageIsImage = function(){
        if(this._check){
            var ox = this.ax;
            return ox.checkDocAllPageIsImage();
        }
    }
    /**
     * 获取内容对象数量
     * @returns {*}
     */
    this.getCountentObjects = function(){
        if(this._check){
            var ox = this.ax;
            return ox.getCountentObjects();
        }
    }
    /**
     * 统计签名数量(兼容接口，已存在相同功能接口CountSignatures)
     * @returns {*}
     * @constructor
     */
    this.CountSigns = function(){
        if (this._check()) {
            var ox = this.ax;
            return ox.CountSignatures();
        }
    }
    /**
     * 验证签名
     * @param index {int} 签名索引
     * @param nFlag {int} 标志位
     * @returns {*}
     */
    this.verifySignature = function(index, nFlag){
        if (this._check()) {
            var ox = this.ax;
            return ox.verifySignature(index, nFlag);
        }
    }
    /**
     * 是否启用签名验证
     * @returns {*}
     */
    this.isSignVerify = function(){
        if (this._check()) {
            var ox = this.ax;
            return ox.isSignVerify();
        }
    }
    /**
     * 设置软件模式
     * @param iMode {int}
     * @returns {*}
     */
    this.setReaderMode = function(iMode){
        if (this._check()) {
            var ox = this.ax;
            return ox.setReaderMode(iMode);
        }
    }
    /**
     * 在最后位置签名
     * @returns {*}
     */
    this.signOnLastPosition = function(){
        if (this._check()) {
            var ox = this.ax;
            return ox.signOnLastPosition();
        }
    }
    /**
     * 设置签名扩展数据
     * @param appName {string}
     * @param signatureID {string}
     * @param data {string}
     * @returns {*}
     */
    this.setSignatureExtensionData = function(appName, signatureID, data){
        if (this._check()) {
            var ox = this.ax;
            return ox.setSignatureExtensionData(appName, signatureID, data);
        }
    }
    /**
     * 获取签名已签名值
     * @param signatureID {string}
     * @returns {*}
     */
    this.getSignatureSignedValue = function(signatureID){
        if (this._check()) {
            var ox = this.ax;
            return ox.getSignatureSignedValue(signatureID);
        }
    }
    /**
     * 显示签名
     * @param signatureID {string}
     * @returns {*}
     */
    this.showSignature = function(signatureID){
        if (this._check()) {
            var ox = this.ax;
            return ox.showSignature(signatureID);
        }
    }

    this.getSignatureSeal = function(signatureID){
        if (this._check()) {
            var ox = this.ax;
            return ox.getSignatureSeal(signatureID);
        }
    }
    /**
     * 根据设置进行签名
     * @param settings {string}
     * @returns {*}
     */
    this.sealSignBySetting = function(settings){
        if (this._check()) {
            var ox = this.ax;
            return ox.sealSignBySetting(settings);
        }
    }





















//end 2024.1.11 mlj 增加暂未实现接口------------------------------------------------------------------

//----------------------------------star打印接口(暂未实现)--------------------------------------------
    /**
     * 说明：设置打印份数【设定后不可通过界面更改】
     * 原型：void setPrintSettings(const QString &strSettings);
     * 参数：strSettings [in]打印设置 //strSettings = {"PrintCopies":3}
     * 返回值：无
     */
    this.setPrintCopies = function(number){
        if(this._check){
            var ox = this.ax;
            // console.log(JSON.stringify('{"PageCopies":'+ number +'}'));
            return ox.setPrintSettings('{"PageCopies":' + number +'}');
        }
    }
    /**
     * 说明：设置打印份号
     * 原型：void setPrintSettings(const QString &strSettings);
     * 参数：strSettings [in]打印设置 //strSettings = {"PrintNo":0001}
     * 返回值：无
     */
    this.setPrintCopyNo = function(printCopyNo){
        if(this._check){
            var ox = this.ax;

            return ox.setPrintSettings('{"PrintNo":'+ printCopyNo +'}');
        }
    }
    /**
     * 说明：设置打印机【通过名称指定打印机】
     * 原型：void setPrintSettings(const QString &strSettings);
     * 参数：strSettings [in]打印设置 //strSettings = {"PrinterName":Microsoft Print to PDF}
     * 返回值：无
     */
    this.setPrinterName = function(printer){
        if(this._check){
            var ox = this.ax;
            return ox.setPrintSettings('{"PrinterName":' + printer + '}');
        }
    }
    /**
     * 说明：设置打印机分辨率【设置打印质量】
     * 原型：void setPrintSettings(const QString &strSettings);
     * 参数：strSettings [in]打印设置 //strSettings = {"PrintDpi":96}
     * 返回值：无
     */
    this.setPrintResolution = function(printDpi){
        if(this._check){
            var ox = this.ax;
            return ox.setPrintSettings('{"PrintDpi":' + printDpi + '}');
        }
    }
    /**
     * 说明：打印时是否允许打印印章【设置印章是否可以打印】
     * 原型：void setPrintSettings(const QString &strSettings);
     * 参数：strSettings [in]打印设置 //strSettings = {"EnabledSeal":1}
     * 返回值：无
     */
    this.setPrintSealEnable = function(isEnable){
        if(this._check){
            var ox = this.ax;
            return ox.setPrintSettings('{"EnabledSeal":' + isEnable + '}');
        }
    }
    /**
     * 说明：指定份数并打印文档
     * 原型：void printFileBySetting(const QString& strSettings);
     * 参数：strSettings [in]打印参数 //strSettings = {"PrintCopies":3}
     * 返回值：无
     * @param copies
     * @returns {*}
     */
    this.printFileCopies = function(copies){
        if(this._check){
            var ox = this.ax;
            return ox.printFileBySetting('{"PrintCopies":'+ copies +'}');
        }
    }
    /**
     * 说明：设置打印份数和份数名称并打印文档
     * 原型：void printFileBySetting(const QString& strSettings);
     * 参数：strSettings [in]打印参数 //strSettings = {"PrintCopies":3,"CopyName":007}
     * 返回值：无
     * @param printSetting
     * @returns {*}
     */
    this.printFileBySetting = function(printSetting){
        if(this._check){
            var ox = this.ax;
            return ox.printFileBySetting(printSetting);
        }
    }
    /**
     * 说明：设置打印份数和份数名称并打印文档
     * 原型：void printFileBySetting(const QString& strSettings);
     * 参数：strSettings [in]打印参数 //strSettings = {"PrintCopies":3,"CopyName":007}
     * 返回值：无
     * @param copies
     * @param copyName
     * @returns {*}
     */
    /*    this.printFile = function(copies, copyName){
            if(this._check){
                var ox = this.ax;
                return ox.printFileBySetting('{"PrintCopies":'+ copies +',"CopyName":' + copyName + '}');
            }
        }*/
    /**
     * 说明：根据打印参数打印文档
     * 原型：void printFileBySetting(const QString& strSettings);
     * 参数：strSettings [in]打印参数 //strSettings = {"DocName":Demo.ofd,"CopyName":008}
     * 返回值：无
     * @param docName
     * @param bGrayPrint
     * @returns {*}
     */
    this.printFile2 = function(docName, bGrayPrint){
        if(this._check){
            var ox = this.ax;
            return ox.printFileBySetting('{"DocName":' + docName + ',"CopyName":' + bGrayPrint + '}');
        }
    }
    /**
     *  该接口传入两个参数时表示：设置打印份数和份数名称并打印文档
     *         传入三个参数表示：设置作业名、灰度打印和是否静默选项并打印文档
     * @param a
     * @param b
     * @param isQuietPrint
     * @returns {*}
     */
  /*  this.printFile = function(a, b, isQuietPrint){
        var paramNum = arguments.length;
        switch (paramNum){
            case 2:
                if(this._check){
                    var ox = this.ax;
                    return ox.printFileBySetting('{"PrintCopies":'+ a +',"CopyName":' + b + '}');
                }
            case 3:
                if(this._check){
                    var ox = this.ax;
                    return ox.printFileBySetting(a, b, isQuietPrint);
                }
        }

    }*/
    /**
     * 说明：打印后退出
     * 原型：void printFileBySetting(const QString& strSettings);
     * 参数：strSettings [in]打印参数 //strSettings = {"QuietPrint":true,"Exit":true}
     * 返回值：无
     * @returns {*}
     */
    this.exitAfterPrint = function(){
        if(this._check){
            var ox = this.ax;
            return ox.printFileBySetting('{"QuietPrint":true,"Exit":true}');
        }
    }
    /**
     * 说明：设置打印设置界面指定组件的选中状态
     * 原型：void setPrintCompsiteChecked(const QString &strCmpName, bool bChecked);
     * 参数：strCmpName [in]组件名称; bChecked [in]选中状态
     * 返回值：无
     * @param cmpName
     * @param bChecked
     * @returns {*}
     */
    this.setPrintCompsiteChecked = function(cmpName, bChecked){
        if(this._check){
            var ox = this.ax;
            return ox.setPrintCompsiteChecked(cmpName, bChecked);
        }
    }
    /**
     * 说明：设置打印界面中指定控件的可用状态【扩展：是否允许设置一组？】
     * 原型：void setPrintCompsiteEnabled(const QString &strCmpName, bool bEnabled);
     * 参数：strCmpName [in]组件名称; bChecked [in]选中状态
     * 返回值：无
     * @param cmpName
     * @param bEnable
     * @returns {*}
     */
    this.setPrintCompsiteEnable = function(cmpName, bEnable){
        if(this._check){
            var ox = this.ax;
            return ox.setPrintCompsiteEnabled(cmpName, bEnable);
        }
    }
    /**
     * 说明：显示打印设置界面
     * 原型：void showPrintSetting();
     * 参数：无
     * 返回值：无
     * @returns {*}
     */
    this.showPrintSetting = function(){
        if(this._check){
            var ox = this.ax;
            return ox.showPrintSetting();
        }
    }
    /**
     * 说明：判断是否静默打印
     * 原型：QString getPrintSettings(const QString &strSettings);
     * 参数：strSettings [in]参数名称 //strSettings = {"QuietPrint":true}
     * 返回值：打印参数
     * @returns {*}
     */
    this.isQuietPrinting = function(){
        if(this._check){
            var ox = this.ax;
            return ox.getPrintSettings('{"QuietPrint":true}');
        }
    }
    /**
     * 说明：获取当前打印机名称【湖南省高级人民法院新增】
     * 原型：QString getPrintSettings(const QString &strSettings);
     * 参数：strSettings [in]参数名称 //strSettings = {"PrinterName":true}
     * 返回值：打印参数
     * @param json
     * @returns {*}
     */
    this.getPrinterNames = function(){
        if(this._check){
            var ox = this.ax;
            return ox.getPrintSettings('{"PrinterName":true}');
        }
    }
    /**
     * 说明：获取文档打印份数
     * 原型：QString getPrintSettings(const QString &strSettings);
     * 参数：strSettings [in]参数名称 //strSettings = {"PrintCopies":true}
     * 返回值：打印参数
     * @param json
     * @returns {*}
     */
    this.printCopies = function(){
        if(this._check){
            var ox = this.ax;
            // console.log(JSON.stringify(ox.getPrintSettings('{"PageCopies":true}')))
            var result =JSON.parse(ox.getPrintSettings('{"PageCopies":1}'));
            return result.PageCopies;
        }
    }
    /**
     * 说明：获取信封打印份数
     * 原型：QString getPrintSettings(const QString &strSettings);
     * 参数：strSettings [in]参数名称 //strSettings = {"EnvelopeCopies":true}
     * 返回值：打印参数
     * @returns {*}
     */
    this.getEnvelopePrintCopies = function(){
        if(this._check){
            var ox = this.ax;
            var result =JSON.parse(ox.getPrintSettings('{"EnvelopeCopies":1}'));
            return result.PageCopies;
        }
    }
    /**
     * 说明：获取打印设置数据
     * 原型：QString getPrintSettings(const QString &strSettings);
     * 参数：strSettings [in]参数名称 //strSettings = NULL
     * 返回值：打印参数
     * @returns {*}
     */
    this.printSetting = function(){
        if(this._check){
            var ox = this.ax;
            return ox.getPrintSettings('NULL');
        }
    }



// ----------------------------------end 打印接口（暂未实现）--------------------------------------------------





};

/**
 * 快速加载并初始化OCX控件,返回OCX实例
 *
 * @param div
 *            div的id,ocx放置于此div内.如果为null,则自动创建一个div并追加于body的最后
 * @param width
 *            宽度,如果为null或auto,则设置为100%,也可以设置为具体像素(如500px)
 * @param height
 * @param width
 *            高度,如果为null或auto,则设置为100%,也可以设置为具体像素(如500px)
 * @param downURL
 *            控件安装程序的下载地址,只有在检查到控件未安装时才有用.若未设置,则不会出现下载地址.
 */
OFD.OCX.init = function (div, width, height, downURL) {
    console.log("yozo:进入init")
    var config = {};
    var tmp = arguments.callee.toString().match(/\(.*?\)/)[0];
    var names = tmp.replace(/[()\s]/g, '').split(',');
    var array = Array.prototype.slice.call(arguments, 0);

    OFD._each(array, function (i, e) {
        if (OFD._isValid(e)) {
            if (OFD._isPlainObject(e)) {
                OFD._extend(e, config);
            } else {
                config[names[i]] = e;
            }
        }
    });

    return new OFD.OCX(config).load();
};

//加载并初始化阅读器OCX控件--application/xReader-ofd
init = function (divID, width, height) {
    return OFD.OCX.init(divID, width, height);
};
