var funcs = function (ready) {
    var tool = {
        // 保存页面中所有的OCX实例
        _OCX_Array: [],
        // 使用id查找实例
        find: function (id) {
            var ocx = null;
            this._each(this._OCX_Array, function (i, e) {
                if (e._id === id) {
                    ocx = e;
                    return false;
                }
            });
            return ocx;
        },
        // 合并对象
        _extend: function (defs, target) {
            var r = target;
            if (this._isNull(r)) {
                if (this._isArray(defs)) {
                    r = [];
                } else {
                    r = {};
                }
            }
            this._each(defs, function (n, v) {
                if (!(n in r)) {
                    r[n] = v;
                }
            });
            return r;
        },
        // 判断参数是否是数组
        _isArray: function (v) {
            return Object.prototype.toString.call(v) === "[object Array]";
        },
        // 判断是否为纯粹对象,like jquery.isPlainObject
        _isPlainObject: function (v) {
            // Must be an Object.
            // Because of IE, we also have to check the presence of the constructor
            // property.
            // Make sure that DOM nodes and window objects don't pass through, as
            // well
            if (!v || v.toString() !== "[object Object]" || v.nodeType
                || "setInterval" in v) {
                return false;
            }
            try {
                // Not own constructor property must be Object
                if (v.constructor && !v.hasOwnProperty("constructor")
                    && !v.constructor.prototype.hasOwnProperty("isPrototypeOf")) {
                    return false;
                }
            } catch (e) {
                // IE8,9 Will throw exceptions on certain host objects #9897
                return false;
            }
            // Own properties are enumerated firstly, so to speed up,
            // if last one is own, then all properties are own.
            var key;
            for (key in v) {
            }
            return key === undefined || v.hasOwnProperty(key);
        },
        // 判断参数是否是undefined或null
        _isNull: function (v) {
            return typeof v == "undefined" || (v !== 0 && !v);
        },
        // 判断参数是有有效
        _isValid: function (v) {
            return this._isNull(v) !== true;
        },
        // getElementById
        _$: function (id) {
            return document.getElementById(id);
        },
        // createElement
        _new: function (tag) {
            return document.createElement(tag);
        },
        // for each like jquery
        _each: function (o, fn) {
            if (this._isArray(o)) {
                for (var i = 0, ol = o.length, val = o[0]; i < ol
                && fn.call(val, i, val) !== false; val = o[++i]) {
                }
            } else {
                for (var i in o) {
                    if (fn.call(o[i], i, o[i]) === false) {
                        break;
                    }
                }
            }
            return o;
        },
        // 一些页面方法
        Page: {
            // 获取窗口宽度
            width: function () {
                var w = 0;
                if (window.innerWidth) {
                    w = window.innerWidth;
                } else if ((document.body) && (document.body.clientWidth)) {
                    w = document.body.clientWidth;
                }
                // 通过深入Document内部对body进行检测，获取窗口大小
                if (document.documentElement
                    && document.documentElement.clientHeight
                    && document.documentElement.clientWidth) {
                    w = document.documentElement.clientWidth;
                }
                return w;
            },
            // 获取窗口高度
            height: function () {
                var h = 0;
                if (window.innerHeight) {
                    h = window.innerHeight;
                } else if ((document.body) && (document.body.clientHeight)) {
                    h = document.body.clientHeight;
                }
                // 通过深入Document内部对body进行检测，获取窗口大小
                if (document.documentElement
                    && document.documentElement.clientHeight
                    && document.documentElement.clientWidth) {
                    h = document.documentElement.clientHeight;
                }
                return h;
            },
            // 兼容FF和IE的事件，当e未定义的时候返回window.event
            dEvent: function (e) {
                if (!e) {
                    return window.event;
                } else {
                    return e;
                }
            }
        }
    }

    this._optCache = ready._optCache;
    this.ax = ready.ax;
    this._check = function () {
        return tool._isValid(this.ax);
    };

    /**
     *  打开指定的本地或远程OFD或PDF文件。
     * @param filename  可以是本地文件路径、远程文件路径（http链接）
     * @param readOnly  是否以只读模式打开。true-只读，false-非只读。
     * @param strSaveUrl  远程保存地址。以只读模式打开时无效。
     */
    this.openFile = function (filename, readOnly, strSaveUrl) {
        var paramNum = arguments.length;
        if (this._check()) {
            var ox = this.ax;
            switch (paramNum) {
                case 1:
                    var result = ox.openFile(filename);
                    return result;
                case 2:
                    var result = ox.openFile(filename, readOnly);
                    return result;
                case 3:
                    var result = ox.openFile(filename, readOnly, strSaveUrl);
                    return result;
            }
        }

    };

    this.openFileDlg = function () {
        if (this._check()) {
            var ox = this.ax;
            ox.openFile();
        }
    }

    // 将加载或缓存的文件保存到本地磁盘boolean saveFile(in string strURL);
    //strURL保存的位置，可以是本地文件，如“D：/files/xxxxx.ofd”；也可以是远程文件，如“http://localhost:88/files/xxxx.ofd”。
    //2023.6.25 sc add//注意！使用nginx服务器时，client_max_body_size属性默认为1m，此时上传超过1m的文档到服务器时会接口会返回false，无法上传成功，请确保client_max_body_size属性值大于文档的内存大小。
    /**
     * 保存文件，该接口可按需 不传入参数，传入一个参数或传入三个参数方式调用
     * @param path (string) 保存的位置，可以是本地文件，如“D：/files/xxxxx.ofd”；也可以是远程文件，如“http://localhost:88/files/xxxx.ofd”。
     * @param isBase64 (bool)  是否以base64编码保存
     * @param saveFileName (string) 保存的文件名
     * @returns {*}
     */
    this.saveFile = function (path, isBase64, saveFileName) {
        var paramNum = arguments.length;
        switch (paramNum) {
            case 0:
                if (this._check()) {
                    var ox = this.ax;
                    return ox.saveFile();
                }
                break;
            case 1:
                if (this._check()) {
                    console.log(path);
                    return this.ax.saveFile(path);
                } else {
                    this._optCache.savefile.push({p: path});
                }
                break;
            case 3:
                if (this._check()) {
                    var ox = this.ax;
                    return ox.saveFile(path, isBase64, saveFileName);
                }
                break;
        }
    };

    // 关闭当前文件
    this.closeFile = function (bAutoSave = false) {
        if (this._check()) {
            this.ax.closeFile(bAutoSave);
        } else {
            this._optCache.closefile.push({});
        }
        return true;
    };
    // 该接口与新接口重复
    //正常打印-void printFile(in string docName,in boolean bGray)直接打印文件，并按指定的打印任务名称和是否灰度打印设置执行
    this.printFile = function (title, color) {
        if (this._check()) {
            var ox = this.ax;
            ox.printFile(title, color);//this 2019.10.28 add
        }
    }

    //静默打印
    this.quietPrintFile = function (title, color, isquietprint) {
        if (this._check()) {
            var ox = this.ax;
            ox.PrintFile(title, color, isquietprint);
        }
    }

    //打印Dlg
    this.openPrintDlg = function () {
        if (this._check()) {
            var ox = this.ax;
            // document.getElementById('search').focus()
            var info = ox.print();
            return info;
        }
    }

    this.printSet = function (printParam) {
        if (this._check()) {
            var ox = this.ax;
            ox.configPrintOptions(printParam);
        }
    }

    //显示和隐藏组件
    this.setCompositeVisible = function (name, visible) {
        if (this._check()) {
            var o = this.ax;
            if (tool._isArray(name)) {
                tool._each(name, function (i, n) {
                    return o.setCompositeVisible(n, visible);
                });
            } else {
                var info = o.setCompositeVisible(name, visible);
                return info;
            }
        } else {
            this._optCache.compsite.push(
                {
                    n: name,
                    v: visible
                });
        }
    };

    //启用/禁用组件
    this.setCompositeEnable = function (name, visible) {
        if (this._check()) {
            var o = this.ax;
            if (tool._isArray(name)) {
                tool._each(name, function (i, n) {
                    o.setCompositeEnable(n, visible);
                });
            } else {
                o.setCompositeEnable(name, visible);
            }
        } else {
            this._optCache.compsite.push(
                {
                    n: name,
                    v: visible
                });
        }
    };

    //设置视图首选项void setViewPreference(in string key,in string val);
    this.setViewPreference = function (key, value) {
        if (this._check()) {
            var o = this.ax;
            o.setViewPreference(key, value);
        }
        //return this;
    };

    //设置页面显示比例void setZoomRadio(in float zoomValue);zoomValue  页面显示比例的值，例如：120表示120%。
    this.setZoomRadio = function (zoomvalue) {
        if (this._check()) {
            var ox = this.ax;
            ox.setZoomRadio(zoomvalue);
        }
    }

    //获取页面显示比例。返回值说明：页面显示比例值，例如：120表示120%
    this.getZoomRadio = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getZoomRadio();
        }
    }
    //设置当前的用户名（用于注释和操作日志)boolean setUserName(in string userName);
    this.setUserName = function (uname) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setUserName(uname);
        }
    }
    //设置印章标识void setSealId(in string sealId);--设置将要应用的印章标识。设置了此值后，将不能对当前文档应用与该标识不匹配的电子印章，此函数常用于配合用章授权。
    this.setSealId = function (uid) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setSealId(uid);
        }
    }

    //打印Dlg
    this.openSealDlg = function () {
        if (this._check()) {
            var ox = this.ax;
            ox.sign();
        }
    }

    //获取用户名
    this.getUserName = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getUserName();
        }

    }

    //增加文档元数据void setMetaData(in string id,in string val); id键见电子公文元数据标识，也可任意值
    this.setMetaData = function (key, value) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setMetaData(key, value);
        }
    }

    //获取文档元数据string getMetaData(in string id);
    this.getMetaData = function (key) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getMetaData(key);
        }
    }

    //设置日志服务地址void setLogSvrURL(in string url);--设置了日志服务地址后，写入日志文件的消息将同时按照标准HTTP协议写入日志服务。
    this.setLogSvrURL = function (url) {
        if (this._check()) {
            var ox = this.ax;
            ox.setLogSvrURL(url);
        }
    }

    //添加追踪水印void addTrackInfo(in string xmlParam);--水印信息将用于显示或打印文档。水印信息格式见附录E
    this.addTrackInfo = function (xmlParam, bSave = true) {//2024.1.26 wxy
        if (this._check()) {
            var ox = this.ax;
            ox.addTrackInfo(xmlParam, bSave);
        }
        //return this;
    };

    //清除水印
    this.clearTrackInfo = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.clearTrackInfo();
        }
    }

    //获取公文域内容string getTaggedText(in string tagId);--从文档中获取指定名称的公文语义标引的内容
    //tagId--例如“电子公文/公文体/版头/密级”，见GB/T 33476.1-2016
    this.getTaggedText = function (docdomain) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getTaggedText(docdomain);
        }
    }

    //获取日志文件路径string getLogFilePath();此接口用于获取版式阅读软件日志文件路径，软件通过日志文件，将内部操作(如打印、签名、验签等)进行记录和汇报。
    //日志文件格式见附录F
    this.getLogFilePath = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getLogFilePath();
        }
    }
//以上为规范标准接口--wcs备注

    this.about = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.about();
        }
    }
    this.saveAs = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.saveAs();
        }
    }
    this.closeAllFiles = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.closeAllFiles();
        }
    }
    this.zoomIn = function () {
        if (this._check()) {
            var ox = this.ax;
            ox.zoomIn();
        }
    }
    this.zoomOut = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.zoomOut();
        }
    }
    this.selectAll = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.selectAll();
        }
    }
    this.getCurrentPageNum = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getCurrentPageNum();
        }
    }
    this.gotoFirstPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoFirstPage();
        }
    }
    this.gotoLastPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoLastPage();
        }
    }
    this.gotoPrevPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoPrevPage();
        }
    }
    this.gotoNextPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoNextPage();
        }
    }
    this.gotoPage = function (nPageNum) {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoPage(nPageNum);
        }
    }
    this.fitWidth = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.fitWidth();
        }
    }
    this.gotoLastPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoLastPage();
        }
    }
    this.fitPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.fitPage();
        }
    }
    this.navBarShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.navBarShowed();
        }
    }
    this.isToolBarShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isToolBarShowed();
        }
    }
    this.isFileToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isFileToolShowed();
        }
    }
    this.isZoomToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isZoomToolShowed();
        }
    }
    this.isZoomModeShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isZoomModeShowed();
        }
    }
    this.isPageToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isPageToolShowed();
        }
    }
    this.isSelectToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isSelectToolShowed();
        }
    }
    this.isSearchToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isSearchToolShowed();
        }
    }
    this.isSignAndWaterMrksToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isSignAndWaterMrksToolShowed();
        }
    }
    this.isAnnoToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isAnnoToolShowed();
        }
    }
    this.isPageLayoutShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isPageLayoutShowed();
        }
    }
    this.isRotateToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isRotateToolShowed();
        }
    }
    this.onOffNavBar = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffNavBar(bHide);
        }
    }
    this.onOffToolBar = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffToolBar(bHide);
        }
    }
    this.onOffFileTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffFileTool(bHide);
        }

    }
    this.onOffZoomTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffZoomTool(bHide);
        }
    }
    this.onOffZoomModeTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffZoomModeTool(bHide);
        }
    }
    this.onOffPageTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffPageTool(bHide);
        }
    }
    this.onOffSelectTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffSelectTool(bHide);
        }
    }
    this.onOffSearchTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffSearchTool(bHide);
        }
    }
    this.onOffSignAndWaterMrksTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffSignAndWaterMrksTool(bHide);
        }
    }
    this.onOffAnnoTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffAnnoTool(bHide);
        }
    }
    this.onOffPageLayout = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffPageLayout(bHide);
        }
    }
    this.onOffRotateTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffRotateTool(bHide);
        }
    }

    // 设置印章名称
    this.setSealName = function (path) {
        if (this._check()) {
            this.ax.setSealName(path);
        } /*else {
            this._optCache.setSealName.push({
                p: path
            });
        }*/
        // return this;
    };

    // 设置签名算法
    this.setSealSignMethod = function (path) {
        if (this._check()) {
            this.ax.setSealSignMethod(path);
        } else {
            this._optCache.sealname.push({
                p: path
            });
        }
        // return this;
    };

    //
    this.setLogURL = function (strurl, oid) {
        if (this._check()) {
            var ox = this.ax;
            ox.setLogURL(strurl, oid);
        }
        // return this;
    };

    this.HidePanels = function (nHide) {
        if (this._check()) {
            var ox = this.ax;
            //ox.HidePanels(parseInt(nHide));//htfoxit
            var bHide = Boolean(nHide);
            ox.onOffNavBar(bHide);//this 2019.10.28 add
        }
    }

    this.setPrintInfo = function (num) {
        if (this._check()) {
            var ox = this.ax;
            ox.setPrintInfo(parseInt(num));
        }
        // return this;
    };


    //设置阅读模式--2019.10.29 waiting ....
    this.setDisPlayMode = function (disPlayMode) {
        if (this._check()) {
            var ox = this.ax;
            ox.setDisPlayMode(parseInt(disPlayMode));
        }
    }

    //设置显示宽度
    this.setZoomMode = function (zoomMode) {
        if (this._check()) {
            var ox = this.ax;
            //ox.setZoomMode(parseInt(zoomMode));//htfoxit
            //this 2019.10.28 add
            var val = parseInt(zoomMode);
            if (val == 1) ox.fitPage();
            else if (val == 2) ox.fitWidth();
            else if (val == 0) ox.zoomReset();
            else if (val == 3) ox.fitHeight();//2021.3.17 zs add
        }
    }

    //获取版本号
    this.getPluginVersion = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getPluginVersion();
        }
    }
    //注销
    this.destroyOCX = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.DestroyOCX();
        }
    }

    //获取公文域位置
    this.getTaggedPosition = function (docdomain) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getTaggedPosition(docdomain);
        }
    }

    //设置打开文档权限
    this.removeAppPermission = function (permission) {
        if (this._check()) {
            var ox = this.ax;
            return ox.removeAppPermission(permission);
        }
    }

    //判断是否正在打印
    this.IsQuietPrinting = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.IsQuietPrinting();
        }
    }

    //判断是否正在签章
    this.IsSigning = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.IsSigning();
        }
    }

    //静默打印设置
    this.printSetting = function () {
        if (this._check()) {
            var ox = this.ax;
            ox.printSetting();
        }
    }

    //本地保存
    this.saveToLocal = function (path) {
        if (this._check()) {
            var ox = this.ax;
            return ox.saveToLocal(path);
        }
    }

    //获取当前页的页码
    this.GetCurPageIndex = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getCurrentPageNum();//this 2019.10.28 add
        }
    }

    //获取当前文档页数
    this.getPageCount = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getPageCount();//2019.10.28 same
        }
    }
    //翻页
    this.GotoPage = function (index) {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoPage(parseInt(index));//this 2019.10.28 add
        }
    }

    //打开首页上半部分盖有多个印章的文档
    this.openSignFile = function (url) {
        if (this._check()) {
            var ox = this.ax;
            return ox.openSignFile(url);
        }
    }

    //获取签章个数
    this.CountSignatures = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.CountSignatures();
        }
    }

    //是否有签章
    this.hasSign = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.hasSign();
        }
    }

    //PDF导出OFD
    //[in]url:导出后ofd文件的目标位置,可以是本地文件，如“D：/files/xxxxx.ofd”；也可以是远程文件，如“http://localhost:8080/exm/Test1”。
    //[in]dpi:图像分辨率，默认96，范围[96,1200]
    //[out]导出成功返回true，失败返回false
    this.pdf2ofd = function (url, dpi) {
        if (this._check()) {
            var ox = this.ax;
            return ox.pdf2ofd(url, dpi);
        }
    }

    /**
     * pdf文件转成ofd文件
     * @param pszPdfUrl {string} PDF文件URL
     * @param PszOfdUrl {string} OFD文件URL
     * @param nBegin {int} 起始页码
     * @param nEnd {int} 结束页码
     * @param nResolution {int} 分辨率
     * @param nResv {int} 保留参数
     * @returns {*}
     */
    this.convertPdfToOfd = function (pszPdfUrl, PszOfdUrl, nBegin, nEnd, nResolution, nResv) {
        if (this._check()) {
            var ox = this.ax;
            return ox.convertPdfToOfd(pszPdfUrl, PszOfdUrl, nBegin, nEnd, nResolution, nResv);
        }
    }

    //根据可配置参数执行模拟点击操作   注：该接口中可以是无参，也可以传入一个参数，也可以传入两个参数
    //[in]  commandId
    //[in]  params
    //[返回值] True/False
    this.performClick = function (a, b) {
        var paramNum = arguments.length;
        console.log(paramNum)
        switch (paramNum) {
            case 0:
                if (this._check()) {
                    var ox = this.ax;
                    return ox.performClick();
                }
            case 1:
                if (this._check()) {
                    var ox = this.ax;
                    return ox.performClick(a);
                }
            case 2:
                if (this._check()) {
                    var ox = this.ax;
                    return ox.performClick(a, b);
                }
        }
    }

    //设计签批笔触样式
    //[in] tabletFullsign
    //[返回值] 0
    this.setConfigInfo = function (configName, configValue) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setConfigInfo(configName, configValue);
        }
    }
    //设置签批笔记粗细
    //[in]  size
    //[返回值] true/false
    this.setSignSize = function (size) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setSignSize(size);
        }
    }
    //设置常用签批图片
    //[in]  strJson
    //[返回值] 无
    this.setCommonSigns = function (strJson) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setCommonSigns(strJson);
        }
    }
    //通过接口直接插入文本
    //[in]  strJson
    //[返回值] json
    this.addFreeText = function (strJson) {
        if (this._check()) {
            var ox = this.ax;
            return ox.addFreeText(strJson);
        }
    }
    //设置文本批注默认字体
    //[in]  strJson
    //[返回值] 0
    this.setFreeTextDefaultFont = function (strJson) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setFreeTextDefaultFont(strJson);
        }
    }
    //获取文本信息
    //[in]  id
    //[返回值] json
    this.getFreeTextContentById = function (id) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getFreeTextContentById(id);
        }
    }
    //设置鼠标开关
    //[in]  bSwitch
    //[返回值] 无
    this.AnnotaTextTitleSwitch = function (bSwitch) {
        if (this._check()) {
            var ox = this.ax;
            return ox.AnnotaTextTitleSwitch(bSwitch);
        }
    }
    //设置常用语
    //[in]  strJson
    //[返回值] 无
    this.SetFreqUserdComments = function (strjson) {
        if (this._check()) {
            var ox = this.ax;
            return ox.SetFreqUserdComments(strjson);
        }
    }
    //设置签名图片
    //[in]  strJson
    //[返回值] 0
    this.SetSignatureImageByJson = function (strjson) {
        if (this._check()) {
            var ox = this.ax;
            return ox.SetSignatureImageByJson(strjson);
        }
    }
    /**
     * 设置鼠标悬停在文本框上方时的提示信息
     * @param strjson {string} 文本提示信息Json字符串
     * @returns {*}
     */
    this.SetAnnotaTextTitle = function (strjson) {
        if (this._check()) {
            var ox = this.ax;
            return ox.SetAnnotaTextTitle(strjson);
        }
    }
    /**
     * 设置时间戳格式。
     * @param startTime {string} 描述时间戳格式以及其字体信息的Json字符串
     * @returns {*}
     */
    this.setTimeFormat = function (startTime) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setTimeFormat(startTime);
        }
    }
    //删除指定范围得签批和图章
    //[in]  strJson
    //[返回值] 无
    this.deleteAnnotationByParameter = function (startTime) {
        if (this._check()) {
            var ox = this.ax;
            return ox.deleteAnnotationByParameter(startTime);
        }
    }

    //清空
    //[返回值] true/false
    this.clearHandwrittenAnnotation = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.clearHandwrittenAnnotation();
        }
    }
    //设置环节控制参数
    //[in]  strJson
    //[返回值] 无
    this.SetStepsLimits = function (strJson) {
        if (this._check()) {
            var ox = this.ax;
            return ox.SetStepsLimits(strJson);
        }
    }
    //直接在文件添加图章
    //[in]  annotInfo
    //[返回值] json
    this.addStampAnnot = function (annotInfo) {
        if (this._check()) {
            var ox = this.ax;
            return ox.addStampAnnot(annotInfo);
        }
    }
    //添加跟随鼠标移动图章
    //[in]  annotInfo
    //[返回值] 无
    this.addMovingStamp = function (strJson) {
        if (this._check()) {
            var ox = this.ax;
            return ox.addMovingStamp(strJson);
        }
    }
    //设置自定义图章
    //[in]  strUrls
    //[返回值] json
    this.addStampUrl = function (strUrls) {
        if (this._check()) {
            var ox = this.ax;
            return ox.addStampUrl(strUrls);
        }
    }
    //根据用户ID、环节标识、注释类型、页码范围获取注释的信息
    //[in]  param
    //[返回值] json
    this.getAnnotInfoBy = function (param) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getAnnotInfoBy(param);
        }
    }
    //电子签章等比例拉伸设置
    //[in]  str
    //[返回值] 无
    this.SetNotDrawdragControl = function (str) {
        if (this._check()) {
            var ox = this.ax;
            return ox.SetNotDrawdragControl(str);
        }
    }
    //电子签章默认缩放大小比例
    //[in]  bIsResize
    //[in]  Height
    //[in]  width
    //[返回值] 无
    this.SetKeepStampRatioParam = function (bIsResize, height, width) {
        if (this._check()) {
            var ox = this.ax;
            return ox.SetKeepStampRatioParam(bIsResize, height, width);
        }
    }
    //设置添加人名章
    //[in]  strJson
    //[返回值] 无
    this.importSignatureImage = function (strJson) {
        if (this._check()) {
            var ox = this.ax;
            return ox.importSignatureImage(strJson);
        }
    }

    //添加矩形块
    //[in]  strPos
    //[in]  r
    //[in]  g
    //[in]  b
    //[返回值] 无
    this.insertFillRect = function (strPos, r, g, b) {
        if (this._check()) {
            var ox = this.ax;
            return ox.insertFillRect(strPos, r, g, b);
        }
    }

    //文件是否被编辑标识
    //[返回值] true/false
    this.IsDocomentHasChangedFlag = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.IsDocomentHasChangedFlag();
        }
    }
    //获取指定页的线段位置
    //[返回值] json
    this.GetLinePos = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.GetLinePos();
        }
    }
    //保存签批内容扩展
    //[in]  strURL
    //[返回值] Success/Error
    this.saveFileRetResult = function (strURL) {
        if (this._check()) {
            var ox = this.ax;
            return ox.saveFileRetResult(strURL);
        }
    }

    /**
     * 合并文件
     * @param strJson {json} JSON格式的文件信息
     * @returns {*} 0
     */
    this.mergeFiles = function (strJson) {
        if (this._check()) {
            var ox = this.ax;
            return ox.mergeFiles(strJson);
        }
    }
    //跳到指定页
    //[in]  nPage
    //[返回值] 0
    this.turnToPage = function (nPage) {
        if (this._check()) {
            var ox = this.ax;
            return ox.turnToPage(nPage);
        }
    }

    //设置即将打开文档禁止操作权限
    //[in]  strJson
    //[返回值] 无
    this.setUserAnnotPermission = function (strJson) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setUserAnnotPermission(strJson);
        }
    }
    //设置配置信息
    //[in]  strUserID
    //[返回值] true/false
    this.setUserId = function (strUserID) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setUserId(strUserID);
        }
    }
    //设置用户名
    //[in]  strUserName
    //[返回值] true/false
    this.setUserName = function (strUserName) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setUserName(strUserName);
        }
    }
    //获取保存的临时配置项值
    //[in]  str
    //[返回值] 获取到的本地保存的临时配置项的值
    this.GetConfigInfo = function (str) {
        if (this._check()) {
            var ox = this.ax;
            return ox.GetConfigInfo(str);
        }
    }
    //获取阅读器版本
    //[返回值] 对应版本号
    this.version = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.version();
        }
    }
    //获取阅读器版本
    //[返回值] 对应版本号
    this.getAppVersion = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getAppVersion();
        }
    }
    // 获取当前进程PID。
    this.GetCurrentAppPID = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.GetCurrentAppPID();
        }
    }
    //获取全文文本内容
    //[out] 将全文文本内容输出
    this.exportText = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.exportText();
        }
    }
//设置全屏显示

    this.readerFullScreen = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.readerFullScreen();
        }
    }
    //打开添加文号章界面
    this.AddChapter = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.AddChapter();
        }
    }

    this.addImageStamp = function (a) {
        var paramNum = arguments.length;
        switch (paramNum) {
            case 0:
                if (this._check()) {
                    var ox = this.ax;
                    return ox.addImageStamp();
                }
            case 1:
                if (this._check()) {
                    var ox = this.ax;
                    return ox.addImageStamp(a);
                }
        }
    }
    //将已打开的文件保存为base64
    this.saveBase64File = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.saveBase64File();
        }
    }
    //保存页面内容为base64内容流
    // [in] strPageindex 待保存为base64内容流的页面范围，相邻页面中间用'-'，隔开，不相邻页面用','隔开，例如1-3
    // 输出为转换成功的base64内容流
    this.saveBase64FilebyIndex = function (strPageIndex) {
        if (this._check()) {
            var ox = this.ax;
            return ox.saveBase64FilebyIndex(strPageIndex);
        }
    }
    //打开base64文件流的文件
    //[in] stream base64格式文件流
    //[out] 打开成功返回true，打开失败返false
    this.openBase64File = function (stream) {
        if (this._check()) {
            var ox = this.ax;
            return ox.openBase64File(stream);
        }
    }
    //[out]成功返回交号章id号
    this.AddChapterByIDAndUrl = function (strJson) {
        if (this._check()) {
            var ox = this.ax;
            return ox.AddChapterByIDAndUrl(strJson);
        }
    }

    //2023.12.26 mlj add--------------------------------------------------补充接口
    //打开当前打开文档属性（元数据）对话框
    this.on_propsAct_triggered = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.on_propsAct_triggered();
        }
    }
    //设置密级标志信息。
    //[in]strMBInfo，string，密级标识信息Json字符串
    this.setMBInfo = function (strMBInfo) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setMBInfo(strMBInfo);
        }
    }
    //重置缩放比
    this.zoomReset = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.zoomReset();
        }
    }
    //打开当前打开文档元数据对话框。可进行元数据设置、权限修改等。
    this.getMetaDataWindow = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getMetaDataWindow();
        }
    }

    this.getUserId = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getUserId();
        }
    }
    //  设置文本批注时，字体下拉框内的可选字体。
    this.SetFreeTextFontsGather = function (strFonts) {
        if (this._check()) {
            var ox = this.ax;
            return ox.SetFreeTextFontsGather(strFonts);
        }
    }
    // 在文本批注字体集合中添加字体
    this.AddFreeTextFontsGather = function (strFonts) {
        if (this._check()) {
            var ox = this.ax;
            return ox.AddFreeTextFontsGather(strFonts);
        }
    }
    //  在文本批注字体集合中删除字体
    this.SubFilterFontsGather = function (strFonts) {
        if (this._check()) {
            var ox = this.ax;
            return ox.SubFilterFontsGather(strFonts);
        }
    }
    //2024.1.11 mlj add 补充接口
    this.onOffMenuBarPermanently = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffMenuBarPermanently(bHide);
        }
    }
    //2024.2.26 wxy
    this.onOffToolBarPermanently = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffToolBarPermanently(bHide);
        }
    }
    this.onOffToolMenuPermanently = function (strToolName, bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffToolMenuPermanently(strToolName, bHide);
        }
    }
    /**
     * 2024.4.2 add
     * 判断当前文档是否被修改
     * @returns {*}
     */
    this.isDocumentModified = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.IsDocomentHasChangedFlag();
        }
    }
    /**
     * 2024.4.2 add
     * 获取文档当前页码
     * @returns {*}
     */
    this.getCurrentPageIndex = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getCurrentPageNum();
        }
    }
    /**
     * 2024.4.2 add
     * 获取当前打开文档中关键字数量。
     * @param strKeyword{String} 需搜索的关键字字符串。
     * @param bbMatchWholeWord{bool}是否全词匹配。
     * @param bMatchCase{bool}是否区分大小写。
     * @returns {*}当前打开文档中关键字数量。
     */
    this.getSearchResultAmount = function (strKeyword, bbMatchWholeWord, bMatchCase) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getSearchResultAmount(strKeyword, bbMatchWholeWord, bMatchCase);
        }
    }
    /**
     * 2024.4.2 add
     * 获取当前打开文档中关键字的坐标信息
     * @param strKeyword{string} 需搜索的关键字字符串
     * @param pageIndex{int} 需搜索的页码
     * @param bMatchWholeWord{bool} 是否全词匹配。
     * @param bMatchCase{bool}是否区分大小写。
     * @returns {*}当前打开文档中关键字的坐标信息字符串
     */
    this.getTextCoordinates = function (strKeyword, pageIndex, bMatchWholeWord, bMatchCase) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getTextCoordinates(strKeyword, pageIndex, bMatchWholeWord, bMatchCase);
        }
    }
    /**
     * 2024.4.2 add
     * 将附件导入至出当前打开的OFD文档里。
     * @param strFilePath{string} 本地附件的绝对路径
     * @returns {*}
     */
    this.ImportAttachment = function (strFilePath) {
        if (this._check()) {
            var ox = this.ax;
            return ox.ImportAttachment(strFilePath);
        }
    }
    /**
     * 2024.4.2 add
     * 获取本机IP和MAC地址信息。
     * @returns {*} IP和MAC地址json字符串。
     */
    this.getIPMacAddress = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getIPMacAddress();
        }
    }
    /**
     * 2024.4.2 add
     * 获取当前ofd文档中签章个数。
     * @returns {*}
     */
    this.getSignaturesCount = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getSignaturesCount();
        }
    }
    /**
     * 2024.4.2 add
     * 批量验证当前ofd文档中的签章，并以对话框显示验证结果。
     * @param bOnline{bool} 是否在线验证
     * @param strSignIds{string}指定多个签章标识时，逗号分隔的签名的标识队列（数字与导航栏中签章列表对应，从1开始）。为空或“all”时验证所有签名。
     * @returns {*}
     */
    this.validSignature = function (bOnline, strSignIds) {
        if (this._check()) {
            var ox = this.ax;
            return ox.validSignature(bOnline, strSignIds);
        }
    }
    /**
     * 2024.4.10 add
     * 在当前打开的OFD文档上进行印章脱密。
     * @param decryptInfo{string} 脱密信息Json字符串。
     * @returns {*} 若脱密后保存base64数据成功则返回base64数据，否则返回空。
     */
    this.decryptAllSealsEx = function (decryptInfo) {
        if (this._check()) {
            var ox = this.ax;
            return ox.decryptAllSealsEx(decryptInfo);
        }
    }
    /**
     * 2024.4.10 add
     * 设置数据标签（用于注释）。
     * 该信息将同setUserId一起用于注释操作。如同时调用了setUserId和setDataTag，则需要UserId，DataTag都相同，此用户才对此注释有操作权限。
     * @param dataTag{string} 数据标签。
     * @returns {*} 无
     */
    this.setDatatag = function (dataTag) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setDatatag(dataTag);
        }
    }
    /**
     * 2024.4.10 add
     * 设置打印对话框中复选框组件的默认值（是否选中）。
     * 在下次启动插件时需要重新配置。打印内容设置仅OFD文档有效。
     * @param cmpName{string} 组件名称
     * @param bChecked{boolean} 是否选中，true表示选中，false表示不选中。
     * @returns {*} 无
     */
    this.setPrintCompositeChecked = function (cmpName, bChecked) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setPrintCompositeChecked(cmpName, bChecked);
        }
    }

    /**
     * 2024.4.11 add
     * 将当前带签章的文件脱密并下载到本地。
     * @param bBlack{boolean} true 红字变黑字印章变黑（黑章黑头），false 颜色不变。
     * @param fileName{string} 文件名，另存对话框里自动署名。
     * @returns {*}
     */
    this.decryptAllSeals = function (bBlack, fileName) {
        if (this._check()) {
            var ox = this.ax;
            return ox.decryptAllSeals(bBlack, fileName);
        }
    }

    /**
     * 2024.4.11 add
     * 获取阅读器注册状态
     * @returns {*} 0：已注册，其它值表示未注册。
     */
    this.GetReaderRegStatus = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.GetReaderRegStatus();
        }
    }

    /**
     * 2024.4.11 add
     * 获取当前打开的OFD或PDF文档中的当前页文本内容。
     * @param pageIndex {int} 需获取文本的页面索引，从0开始。
     * @returns {*}
     */
    this.getPageTxt = function (pageIndex) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getPageTxt(pageIndex);
        }
    }
    /**
     * 2024.4.11 add
     * 获取当前打开的OFD或PDF文档中的全部文本内容。
     * @returns {*} 文档中的全部文本内容字符串。
     */
    this.getDocumentText = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getDocumentText();
        }
    }


}

var OFD = (function () {
    var tool = {
        // 保存页面中所有的OCX实例
        _OCX_Array: [],
        // 使用id查找实例
        find: function (id) {
            var ocx = null;
            this._each(this._OCX_Array, function (i, e) {
                if (e._id === id) {
                    ocx = e;
                    return false;
                }
            });
            return ocx;
        },
        // 合并对象
        _extend: function (defs, target) {
            var r = target;
            if (this._isNull(r)) {
                if (this._isArray(defs)) {
                    r = [];
                } else {
                    r = {};
                }
            }
            this._each(defs, function (n, v) {
                if (!(n in r)) {
                    r[n] = v;
                }
            });
            return r;
        },
        // 判断参数是否是数组
        _isArray: function (v) {
            return Object.prototype.toString.call(v) === "[object Array]";
        },
        // 判断是否为纯粹对象,like jquery.isPlainObject
        _isPlainObject: function (v) {
            // Must be an Object.
            // Because of IE, we also have to check the presence of the constructor
            // property.
            // Make sure that DOM nodes and window objects don't pass through, as
            // well
            if (!v || v.toString() !== "[object Object]" || v.nodeType
                || "setInterval" in v) {
                return false;
            }
            try {
                // Not own constructor property must be Object
                if (v.constructor && !v.hasOwnProperty("constructor")
                    && !v.constructor.prototype.hasOwnProperty("isPrototypeOf")) {
                    return false;
                }
            } catch (e) {
                // IE8,9 Will throw exceptions on certain host objects #9897
                return false;
            }
            // Own properties are enumerated firstly, so to speed up,
            // if last one is own, then all properties are own.
            var key;
            for (key in v) {
            }
            return key === undefined || v.hasOwnProperty(key);
        },
        // 判断参数是否是undefined或null
        _isNull: function (v) {
            return typeof v == "undefined" || (v !== 0 && !v);
        },
        // 判断参数是有有效
        _isValid: function (v) {
            return this._isNull(v) !== true;
        },
        // getElementById
        _$: function (id) {
            return document.getElementById(id);
        },
        // createElement
        _new: function (tag) {
            return document.createElement(tag);
        },
        // for each like jquery
        _each: function (o, fn) {
            if (this._isArray(o)) {
                for (var i = 0, ol = o.length, val = o[0]; i < ol
                && fn.call(val, i, val) !== false; val = o[++i]) {
                }
            } else {
                for (var i in o) {
                    if (fn.call(o[i], i, o[i]) === false) {
                        break;
                    }
                }
            }
            return o;
        },
        // 一些页面方法
        Page: {
            // 获取窗口宽度
            width: function () {
                var w = 0;
                if (window.innerWidth) {
                    w = window.innerWidth;
                } else if ((document.body) && (document.body.clientWidth)) {
                    w = document.body.clientWidth;
                }
                // 通过深入Document内部对body进行检测，获取窗口大小
                if (document.documentElement
                    && document.documentElement.clientHeight
                    && document.documentElement.clientWidth) {
                    w = document.documentElement.clientWidth;
                }
                return w;
            },
            // 获取窗口高度
            height: function () {
                var h = 0;
                if (window.innerHeight) {
                    h = window.innerHeight;
                } else if ((document.body) && (document.body.clientHeight)) {
                    h = document.body.clientHeight;
                }
                // 通过深入Document内部对body进行检测，获取窗口大小
                if (document.documentElement
                    && document.documentElement.clientHeight
                    && document.documentElement.clientWidth) {
                    h = document.documentElement.clientHeight;
                }
                return h;
            },
            // 兼容FF和IE的事件，当e未定义的时候返回window.event
            dEvent: function (e) {
                if (!e) {
                    return window.event;
                } else {
                    return e;
                }
            }
        }
    }


    var readyInit = function (options) {
        // OCX的Object ID
        this._id;
        // 配置
        this.opts = tool._extend({
            div: null,
            width: "100%",
            height: "100%",//2019.10.30 height: OFD.Page.height() + "px",

            loadMsg: "<span>正在加载控件，请稍候....</span>",
            // 控件安装程序的下载路径
            //downURL : "res/ocx/xReader.exe",
            // 是否检查控件已经安装װ
            checkInstalled: true
        }, options);
        // 控件对象
        this.ax;
        // 缓存用户操作.因为某些情况下,用户操作时,控件还没有初始化完毕
        this._optCache = {
            compsite: [],
            callback: [],
            convert: [],
            perform: [],
            svcaddr: [],
            savefile: [],
            closefile: [],
            open: [],
            enable: [],
            sealname: [],
            sealid: [],
            sealmethod: [],
            opts: {// 属性名称和方法的映射
                "compsite": "setCompositeVisible",
                "callback": "setCallback",
                "convert": "convertFile",
                "perform": "performClick",
                "svcaddr": "setServiceAddr",
                "open": "_open",
                "enable": "setCompositeEnable",
                "savefile": "saveFile",
                "closefile": "closeFile",
                "sealname": "setSealName",
                "sealid": "setSealId",
                "sealmethod": "setSealSignMethod"
            }
        };
        // 内部函数请勿调用-生成随机串
        this._randomString = function (l) {
            var x = "0123456789qwertyuioplkjhgfdsazxcvbnm";
            var tmp = "";
            for (var i = 0; i < l; i++) {
                tmp += x.charAt(Math.ceil(Math.random() * 100000000) % x.length);
            }
            return tmp;
        };
// 加载配置,完成准备工作,只执行一次
        this.ready = function () {
            console.log("yozo:加载配置，完成准备工作")
            if (this.ax) {// 已经初始化
                console.log("yozo:存在插件配置，退出配置程序")
                return;
            }
            var o = tool._$(this._id);
            if (!o)//|| !("openURL" in o))
            {
                var div = tool._$(this.opts.div);
                div.innerHTML = "<span>ActiveX控件未正确初始化!</span>";
                return;
            }
            this.ax = o; // 赋值,很重要
            var _me = this;
            // 控制初始化时的组件显示
            var compsite = this.opts.compsite;
            if (compsite) {
                tool._each(compsite, function (n, v) {
                    //_me.setCompositeVisible(n, v);
                    _me.setCompositeVisible(n, v);
                });
            }
            console.log("yozo:执行缓存动作")
            // 加载完毕前的动作都执行一遍
            tool._each(this._optCache, function (n, v) {
                if (tool._isArray(v) && v.length > 0) {
                    var fn = _me[_me._optCache.opts[n]];
                    if (fn) {
                        tool._each(v, function (i, e) {
                            var args = [];
                            tool._each(e, function (ni, vi) {
                                args.push(vi);
                            });
                            try {
                                fn.apply(_me, args);
                            } catch (e) {
                            }
                        });
                    }

                    v.length = 0; // clear
                }
            });
            console.log("yozo:缓存动作执行完毕")
        };
        this._writeOCX = function () {
            console.log("yozo:创建插件所在标签embed，并且设置宽高及type")
            var w = this.opts.width;
            if (tool._isNull(w) || w == "auto") {
                w = "100%";
            }
            var h = this.opts.height;
            if (tool._isNull(h) || h == "auto") {
                h = "100%"; //2019.10.30 tool.Page.height() + "px";
            }
            tool._$(this.opts.div).innerHTML = "<embed id='" + this._id
                + "' width='" + w
                + "' height='" + h
                + "' type='application/x-reader'"
                + ">"
            console.log("yozo:embed标签创建完毕，加载插件完成")
        };

        // 加载控件
        this.load = function () {
            console.log("yozo:准备加载插件")
            var rand = this._randomString(10);
            var div = tool._$(this.opts.div);
            if (tool._isNull(this.opts.div)) {
                div.innerHTML = "<span style='color:red;'>启动FireFox控件环境未准备好!</span>";
            }
            div.innerHTML = this.opts.loadMsg;
            this._id = "ofdReader_" + rand;
            tool._OCX_Array.push(this); // 放入队列,以方便查找使用
            this._writeOCX();
            this.ready();
            console.log("yozo:---------------插件初始化完成------------------------")
        }
        // 2024.2.26 mlj remove 造成浏览器卡死  会不断触发窗口变化
        // 2024.1.29 mlj add 刷新页面
        /*this.embedChanged = function (width, height){
            //2024.2.2 mlj remove
            // var width = document.getElementById(this._id).offsetWidth;
            // var height = document.getElementById(this._id).offsetHeight;
            // console.log("初始尺寸", width,  height)
            console.log(width, height)
            // 创建观察器对象
            var observer = new MutationObserver((mutationsList) => {
                for (let mutation of mutationsList) {
                    if (mutation.target.offsetWidth !== width || mutation.target.offsetHeight !== height) {
                        // 当样式属性发生改变时，输出新的宽度和高度值
                        mutation.target.style.width = width.toString() + "px";
                        mutation.target.style.height = height.toString() + "px";
                    }
                }
            });
            // 配置观察选项
            const config = {attributes: true , subtree: true};
            // 获取要监听的div元素
            const targetDiv = document.getElementById(this._id);
            // 开始观察目标节点及其子节点的变动
            observer.observe(targetDiv.parentElement, config);
        }*/
    }

    return {
        OCX: {
            init: function (div, width, height) {
                //打包时需要删除old.js文件，重置下方修改日期
                console.log("2024.4.11 xReaderNPAPI:新增4个接口")
                var config = {};
                var tmp = arguments.callee.toString().match(/\(.*?\)/)[0];
                var names = tmp.replace(/[()\s]/g, '').split(',');
                var array = Array.prototype.slice.call(arguments, 0);
                tool._each(array, function (i, e) {
                    if (tool._isValid(e)) {
                        if (tool._isPlainObject(e)) {
                            tool._extend(e, config);
                        } else {
                            config[names[i]] = e;
                        }
                    }
                });
                var ready = new readyInit(config)
                ready.load();
                // 2024.2.26 mlj remove 造成浏览器卡死  会不断触发窗口变化
                // ready.embedChanged(width, height);//2024.1.29 mlj add 修复界面不显示问题
                return new funcs(ready);
            },
        }
    }
})()

//加载并初始化阅读器OCX控件--application/xReader-ofd
init = function (divID, width, height) {
    return OFD.OCX.init(divID, width, height);
}