/*
 * OFD的ActiveX控件使用的js，负责加载和提供接口。
 * js压缩：http://tool.css-js.com/
 */
//通用对象
var OFD = {
    // 保存页面中所有的OCX实例
    _OCX_Array: [],
    // 使用id查找实例
    find: function (id) {
        var ocx = null;
        this._each(this._OCX_Array, function (i, e) {
            if (e._id === id) {
                ocx = e;
                return false;
            }
        });
        return ocx;
    },
    // 合并对象
    _extend: function (defs, target) {
        var r = target;
        if (this._isNull(r)) {
            if (this._isArray(defs)) {
                r = [];
            } else {
                r = {};
            }
        }
        this._each(defs, function (n, v) {
            if (!(n in r)) {
                r[n] = v;
            }
        });
        return r;
    },
    // 判断参数是否是数组
    _isArray: function (v) {
        return Object.prototype.toString.call(v) === "[object Array]";
    },
    // 判断是否为纯粹对象,like jquery.isPlainObject
    _isPlainObject: function (v) {
        // Must be an Object.
        // Because of IE, we also have to check the presence of the constructor
        // property.
        // Make sure that DOM nodes and window objects don't pass through, as
        // well
        if (!v || v.toString() !== "[object Object]" || v.nodeType
            || "setInterval" in v) {
            return false;
        }
        try {
            // Not own constructor property must be Object
            if (v.constructor && !v.hasOwnProperty("constructor")
                && !v.constructor.prototype.hasOwnProperty("isPrototypeOf")) {
                return false;
            }
        } catch (e) {
            // IE8,9 Will throw exceptions on certain host objects #9897
            return false;
        }
        // Own properties are enumerated firstly, so to speed up,
        // if last one is own, then all properties are own.
        var key;
        for (key in v) {
        }
        return key === undefined || v.hasOwnProperty(key);
    },
    // 判断参数是否是undefined或null
    _isNull: function (v) {
        return typeof v == "undefined" || (v !== 0 && !v);
    },
    // 判断参数是有有效
    _isValid: function (v) {
        return this._isNull(v) !== true;
    },
    // getElementById
    _$: function (id) {
        return document.getElementById(id);
    },
    // createElement
    _new: function (tag) {
        return document.createElement(tag);
    },
    // for each like jquery
    _each: function (o, fn) {
        if (this._isArray(o)) {
            for (var i = 0, ol = o.length, val = o[0]; i < ol
            && fn.call(val, i, val) !== false; val = o[++i]) {
            }
        } else {
            for (var i in o) {
                if (fn.call(o[i], i, o[i]) === false) {
                    break;
                }
            }
        }
        return o;
    },
    // 一些页面方法
    Page: {
        // 获取窗口宽度
        width: function () {
            var w = 0;
            if (window.innerWidth) {
                w = window.innerWidth;
            } else if ((document.body) && (document.body.clientWidth)) {
                w = document.body.clientWidth;
            }
            // 通过深入Document内部对body进行检测，获取窗口大小
            if (document.documentElement
                && document.documentElement.clientHeight
                && document.documentElement.clientWidth) {
                w = document.documentElement.clientWidth;
            }
            return w;
        },
        // 获取窗口高度
        height: function () {
            var h = 0;
            if (window.innerHeight) {
                h = window.innerHeight;
            } else if ((document.body) && (document.body.clientHeight)) {
                h = document.body.clientHeight;
            }
            // 通过深入Document内部对body进行检测，获取窗口大小
            if (document.documentElement
                && document.documentElement.clientHeight
                && document.documentElement.clientWidth) {
                h = document.documentElement.clientHeight;
            }
            return h;
        },
        // 兼容FF和IE的事件，当e未定义的时候返回window.event
        dEvent: function (e) {
            if (!e) {
                return window.event;
            } else {
                return e;
            }
        }
    }
};

//OCX类型及方法
OFD.OCX = function (options) {
    // OCX的Object ID
    this._id;
    // 配置
    this.opts = OFD._extend({
        div: null,
        width: "100%",
        height: "100%",//2019.10.30 height: OFD.Page.height() + "px",

        loadMsg: "<span>正在加载控件，请稍候....</span>",
        // 控件安装程序的下载路径
        //downURL : "res/ocx/xReader.exe",
        // 是否检查控件已经安装װ
        checkInstalled: true
    }, options);
    // 控件对象
    this.ax;
    // 缓存用户操作.因为某些情况下,用户操作时,控件还没有初始化完毕
    this._optCache = {
        compsite: [],
        callback: [],
        convert: [],
        perform: [],
        svcaddr: [],
        savefile: [],
        closefile: [],
        open: [],
        enable: [],
        sealname: [],
        sealid: [],
        sealmethod: [],
        opts: {// 属性名称和方法的映射
            "compsite": "setCompositeVisible",
            "callback": "setCallback",
            "convert": "convertFile",
            "perform": "performClick",
            "svcaddr": "setServiceAddr",
            "open": "_open",
            "enable": "setCompositeEnable",
            "savefile": "saveFile",
            "closefile": "closeFile",
            "sealname": "setSealName",
            "sealid": "setSealId",
            "sealmethod": "setSealSignMethod"
        }
    };

    // 加载控件
    this.load = function () {
        console.log("yozo:准备加载插件")
        var rand = this._randomString(10);
        var div = OFD._$(this.opts.div);
        if (OFD._isNull(this.opts.div)) {
            div.innerHTML = "<span style='color:red;'>启动FireFox控件环境未准备好!</span>";
        }
        div.innerHTML = this.opts.loadMsg;
        this._id = "ofdReader_" + rand;
        OFD._OCX_Array.push(this); // 放入队列,以方便查找使用
        this._writeOCX();
        this.ready();
        console.log("yozo:---------------插件初始化完成------------------------")
        // return this;
    };

    // 加载配置,完成准备工作,只执行一次
    this.ready = function () {
        console.log("yozo:加载配置，完成准备工作")
        if (this.ax) {// 已经初始化
            console.log("yozo:存在插件配置，退出配置程序")
            return;
        }
        var o = OFD._$(this._id);
        if (!o)//|| !("openURL" in o))
        {
            var div = OFD._$(this.opts.div);
            div.innerHTML = "<span>ActiveX控件未正确初始化!</span>";
            return;
        }
        this.ax = o; // 赋值,很重要
        var _me = this;
        // 控制初始化时的组件显示
        var compsite = this.opts.compsite;
        if (compsite) {
            OFD._each(compsite, function (n, v) {
                //_me.setCompositeVisible(n, v);
                _me.setCompositeVisible(n, v);
            });
        }
        console.log("yozo:执行缓存动作")
        // 加载完毕前的动作都执行一遍
        OFD._each(this._optCache, function (n, v) {
            if (OFD._isArray(v) && v.length > 0) {
                var fn = _me[_me._optCache.opts[n]];
                if (fn) {
                    OFD._each(v, function (i, e) {
                        var args = [];
                        OFD._each(e, function (ni, vi) {
                            args.push(vi);
                        });
                        try {
                            fn.apply(_me, args);
                        } catch (e) {
                        }
                    });
                }

                v.length = 0; // clear
            }
        });
        console.log("yozo:缓存动作执行完毕")
    };
    // 内部函数请勿调用-生成随机串
    this._randomString = function (l) {
        var x = "0123456789qwertyuioplkjhgfdsazxcvbnm";
        var tmp = "";
        for (var i = 0; i < l; i++) {
            tmp += x.charAt(Math.ceil(Math.random() * 100000000) % x.length);
        }
        return tmp;
    };

    // 内部函数请勿调用-输出控件的html
    this._writeOCX = function () {
        console.log("yozo:创建插件所在标签embed，并且设置宽高及type")
        var w = this.opts.width;
        if (OFD._isNull(w) || w == "auto") {
            w = "100%";
        }
        var h = this.opts.height;
        if (OFD._isNull(h) || h == "auto") {
            h = "100%"; //2019.10.30 OFD.Page.height() + "px";
        }

        OFD._$(this.opts.div).innerHTML = "<embed id='" + this._id
            + "' width='" + w
            + "' height='" + h
            + "' type='application/x-reader'"
            + ">";
        console.log("yozo:embed标签创建完毕，加载插件完成")
    };

    // 内部函数请勿调用-检查组件是否准备完毕
    this._check = function () {
        return OFD._isValid(this.ax);
    };

    // 内部函数请勿调用-打开文件
    this._open = function (type, path, name, bolread) {
        if (type === "file") {
            this.ax.openFile(path, bolread);
            console.log("yozo:调用openFile接口完成")
        }
        // return true;
    };

//以下为规范标准接口--wcs备注
    // 打开文件boolean openFile(in string strURL,in boolean readOnly);
    //strURL文件名，可以是本地文件，如“D:/files/xxxxx.ofd”；也可以是远程文件，如“http://localhost:88/files/xxxx.ofd”。
    /* this.openFile = function (path, bolread) {
         this._open("file", path, name, bolread);
     };*/

    this.openFile = function(path, onlyRead){
        console.log("yozo:调用openFile接口" + "   path:" + path + "    onlyRead:" + onlyRead)
        if(this._check()){
            var ox = this.ax;
            ox.openFile(path, onlyRead)
            console.log("yozo:调用openFile接口完成")
        }
    }

    this.openFileDlg = function () {
        if (this._check()) {
            var ox = this.ax;
            ox.openFile();
        }
    }

    // 将加载或缓存的文件保存到本地磁盘boolean saveFile(in string strURL);
    //strURL保存的位置，可以是本地文件，如“D：/files/xxxxx.ofd”；也可以是远程文件，如“http://localhost:88/files/xxxx.ofd”。
    //2023.6.25 sc add//注意！使用nginx服务器时，client_max_body_size属性默认为1m，此时上传超过1m的文档到服务器时会接口会返回false，无法上传成功，请确保client_max_body_size属性值大于文档的内存大小。
    this.saveFile = function (path) {
        if (this._check()) {
            return this.ax.saveFile(path);
        } else {
            this._optCache.savefile.push({ p: path });
        }
    };

    // 关闭当前文件
    this.closeFile = function () {
        if (this._check()) {
            this.ax.closeFile();
        } else {
            this._optCache.closefile.push({});
        }
        // return true;
    };
    this.onOffMenuBarPermanently = function (bVisible) {//2024.1.5 wxy
        if (this._check()) {
            var ox = this.ax;
            ox.onOffMenuBarPermanently(bVisible);
        }
    };

    //正常打印-void printFile(in string docName,in boolean bGray)直接打印文件，并按指定的打印任务名称和是否灰度打印设置执行
    this.printFile = function (title, color) {
        console.log("yozo:调用printFile接口" + "  title:" + title + "   color:" + color)
        if (this._check()) {
            var ox = this.ax;
            //ox.PrintFile(title, color, 0);//htfoxit
            ox.printFile(title, color);//this 2019.10.28 add
            console.log("yozo:调用printFile接口完成")
        }
    }

    //静默打印
    this.quietPrintFile = function (title, color, isquietprint) {
        if (this._check()) {
            var ox = this.ax;
            ox.PrintFile(title, color, isquietprint);
        }
    }

    //打印Dlg
    this.openPrintDlg = function () {
        console.log("yozo:调用openPrintDlg接口")
        if (this._check()) {
            var ox = this.ax;
            ox.print();
            console.log("yozo:调用openPrintDlg接口完成")
        }
    }

    this.printSet = function (printParam) {
        console.log("yozo:调用printSet接口" + "   printParam:" + printParam)
        if (this._check()) {
            var ox = this.ax;
            ox.configPrintOptions(printParam);
            console.log("yozo:调用printSet接口完成")
        }
    }

    //显示和隐藏组件setCompositeVisible(in string CompName,in boolean bEnable)界面元素的标识，见附录C
    this.setCompositeVisible = function (name, visible) {
        console.log("yozo:调用setCompositeVisible接口" + "    name:" + name + "    visible:" + visible)
        if (this._check()) {
            var o = this.ax;
            if (OFD._isArray(name)) {
                OFD._each(name, function (i, n) {
                    o.setCompositeVisible(n, visible);
                });
                console.log("yozo:调用setCompositeVisible接口完毕")
            } else {
                o.setCompositeVisible(name, visible);
                console.log("yozo:调用setCompositeVisible接口完毕")
            }
        } else {
            this._optCache.compsite.push(
                {
                    n: name,
                    v: visible
                });
        }
    };
    //永久隐藏显示工具栏菜单(in string CompName,in boolean bVisible)界面元素 2024.1.10 wxy
    this.onOffToolMenuPermanently = function (name, visible) {
        if (this._check()) {
            var o = this.ax;
            return o.onOffToolMenuPermanently(name, visible);
        }
    };

    //启用/禁用组件setCompositeEnable(in string CompName,in boolean bEnable)界面元素的标识，见附录C
    this.setCompositeEnable = function (name, visible) {
        if (this._check()) {
            var o = this.ax;
            if (OFD._isArray(name)) {
                OFD._each(name, function (i, n) {
                    o.setCompositeEnable(n, visible);
                });
            } else {
                o.setCompositeEnable(name, visible);
            }
        } else {
            this._optCache.compsite.push(
                {
                    n: name,
                    v: visible
                });
        }
        // return this;
    };

    //设置视图首选项void setViewPreference(in string key,in string val);
    //key:"navigator"; val:"none/outline/thumbnail/semanteme", maybe bookmark/annotation/watermark
    this.setViewPreference = function (key, value) {
        if (this._check()) {
            var o = this.ax;
            o.setViewPreference(key, value);
        }
        //return this;
    };

    //设置页面显示比例void setZoomRadio(in float zoomValue);zoomValue  页面显示比例的值，例如：120表示120%。
    this.setZoomRadio = function (zoomvalue) {
        if (this._check()) {
            var ox = this.ax;
            ox.setZoomRadio(zoomvalue);
        }
    }

    //获取页面显示比例。返回值说明：页面显示比例值，例如：120表示120%
    this.getZoomRadio = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getZoomRadio();
        }
    }

    //设置当前的用户名（用于注释和操作日志)boolean setUserName(in string userName);
    this.setUserName = function (uname) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setUserName(uname);
        }
    }//设置印章标识void setSealId(in string sealId);--设置将要应用的印章标识。设置了此值后，将不能对当前文档应用与该标识不匹配的电子印章，此函数常用于配合用章授权。
    this.setSealId = function (uid) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setSealId(uid);
        }
    }

    //打印Dlg
    this.openSealDlg = function () {
        if (this._check()) {
            var ox = this.ax;
            ox.sign();
        }
    }

    //获取用户名
    this.getUserName = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getUserName();
        }

    }

    // 设置印章标识void setSealId(in string sealId);--设置将要应用的印章标识。设置了此值后，将不能对当前文档应用与该标识不匹配的电子印章，此函数常用于配合用章授权。
//    this.setSealId = function (path) {
//        if (this._check()) {
//            this.ax.setSealId(path);
//        } else {
//            this._optCache.setSealId.push({
//                p: path
//            });
//        }
//        return this;
//    };

    //增加文档元数据void setMetaData(in string id,in string val); id键见电子公文元数据标识，也可任意值
    this.setMetaData = function (key, value) {
        if (this._check()) {
            var ox = this.ax;
            return ox.setMetaData(key, value);
        }
    }

    //获取文档元数据string getMetaData(in string id);
    this.getMetaData = function (key) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getMetaData(key);
        }
    }

    //设置日志服务地址void setLogSvrURL(in string url);--设置了日志服务地址后，写入日志文件的消息将同时按照标准HTTP协议写入日志服务。
    this.setLogSvrURL = function (url) {
        if (this._check()) {
            var ox = this.ax;
            ox.setLogSvrURL(url);
        }
    }

    //添加追踪水印void addTrackInfo(in string xmlParam);--水印信息将用于显示或打印文档。水印信息格式见附录E
    this.addTrackInfo = function (xmlParam) {
        if (this._check()) {
            var ox = this.ax;
            ox.addTrackInfo(xmlParam);
        }
        //return this;
    };

    //清除水印
    this.clearTrackInfo = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.clearTrackInfo();
        }
    }

    //获取公文域内容string getTaggedText(in string tagId);--从文档中获取指定名称的公文语义标引的内容
    //tagId--例如“电子公文/公文体/版头/密级”，见GB/T 33476.1-2016
    this.getTaggedText = function (docdomain) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getTaggedText(docdomain);
        }
    }

    //获取日志文件路径string getLogFilePath();此接口用于获取版式阅读软件日志文件路径，软件通过日志文件，将内部操作(如打印、签名、验签等)进行记录和汇报。
    //日志文件格式见附录F
    this.getLogFilePath = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getLogFilePath();
        }
    }
//以上为规范标准接口--wcs备注

//start here is our ext Interfaces--wcs备注
    this.about = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.about();
        }
    }
    this.saveAs = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.saveAs();
        }
    }
    this.closeAllFiles = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.closeAllFiles();
        }
    }
    this.zoomIn = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.zoomIn();
        }
    }
    this.zoomOut = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.zoomOut();
        }
    }
    this.selectAll = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.selectAll();
        }
    }
    this.getCurrentPageNum = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getCurrentPageNum();
        }
    }
    this.gotoFirstPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoFirstPage();
        }
    }
    this.gotoLastPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoLastPage();
        }
    }
    this.gotoPrevPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoPrevPage();
        }
    }
    this.gotoNextPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoNextPage();
        }
    }
    this.gotoPage = function (nPageNum) {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoPage(nPageNum);
        }
    }
    this.fitWidth = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.fitWidth();
        }
    }
    this.gotoLastPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.gotoLastPage();
        }
    }
    this.fitPage = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.fitPage();
        }
    }
    this.navBarShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.navBarShowed();
        }
    }
    this.isToolBarShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isToolBarShowed();
        }
    }
    this.isFileToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isFileToolShowed();
        }
    }
    this.isZoomToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isZoomToolShowed();
        }
    }
    this.isZoomModeShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isZoomModeShowed();
        }
    }
    this.isPageToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isPageToolShowed();
        }
    }
    this.isSelectToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isSelectToolShowed();
        }
    }
    this.isSearchToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isSearchToolShowed();
        }
    }
    this.isSignAndWaterMrksToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isSignAndWaterMrksToolShowed();
        }
    }
    this.isAnnoToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isAnnoToolShowed();
        }
    }
    this.isPageLayoutShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isPageLayoutShowed();
        }
    }
    this.isRotateToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isRotateToolShowed();
        }
    }
    //2024.1.10 wxy
    this.isEditToolShowed = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.isEditToolShowed();
        }
    }
    this.onOffNavBar = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffNavBar(bHide);
        }
    }
    this.onOffToolBar = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffToolBar(bHide);
        }
    }
    this.onOffFileTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffFileTool(bHide);
        }
    }
    this.onOffZoomTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffZoomTool(bHide);
        }
    }
    this.onOffZoomModeTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffZoomModeTool(bHide);
        }
    }
    this.onOffPageTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffPageTool(bHide);
        }
    }
    this.onOffSelectTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffSelectTool(bHide);
        }
    }
    this.onOffSearchTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffSearchTool(bHide);
        }
    }
    this.onOffSignAndWaterMrksTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffSignAndWaterMrksTool(bHide);
        }
    }
    this.onOffAnnoTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffAnnoTool(bHide);
        }
    }
    this.onOffPageLayout = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffPageLayout(bHide);
        }
    }
    this.onOffRotateTool = function (bHide) {
        if (this._check()) {
            var ox = this.ax;
            return ox.onOffRotateTool(bHide);
        }
    }
//end of here is our ext Interfaces--wcs备注

//以下接口only htfoxit
    // 设置印章名称
    this.setSealName = function (path) {
        if (this._check()) {
            this.ax.setSealName(path);
        } else {
            this._optCache.setSealName.push({
                p: path
            });
        }
        // return this;
    };

    // 设置签名算法
    this.setSealSignMethod = function (path) {
        if (this._check()) {
            this.ax.setSealSignMethod(path);
        } else {
            this._optCache.setSealSignMethod.push({
                p: path
            });
        }
        // return this;
    };

    //
    this.setLogURL = function (strurl, oid) {
        if (this._check()) {
            var ox = this.ax;
            ox.setLogURL(strurl, oid);
        }
        // return this;
    };

    this.HidePanels = function (nHide) {
        if (this._check()) {
            var ox = this.ax;
            //ox.HidePanels(parseInt(nHide));//htfoxit
            var bHide = Boolean(nHide);
            ox.onOffNavBar(bHide);//this 2019.10.28 add
        }
    }

    this.setPrintInfo = function (num) {
        if (this._check()) {
            var ox = this.ax;
            ox.setPrintInfo(parseInt(num));
        }
        // return this;
    };


    //设置阅读模式--2019.10.29 waiting ....
    this.setDisPlayMode = function (disPlayMode) {
        if (this._check()) {
            var ox = this.ax;
            ox.setDisPlayMode(parseInt(disPlayMode));
        }
    }

    //设置显示宽度
    this.setZoomMode = function (zoomMode) {
        if (this._check()) {
            var ox = this.ax;
            //ox.setZoomMode(parseInt(zoomMode));//htfoxit
            //this 2019.10.28 add
            var val = parseInt(zoomMode);
            if(val==1) ox.fitPage();
            else if(val==2) ox.fitWidth();
            else if(val==0) ox.zoomReset();
            else if(val==3) ox.fitHeight();//2021.3.17 zs add
        }
    }

    //获取版本号
    this.getPluginVersion = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getPluginVersion();
        }
    }

    //注销
    this.destroyOCX = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.DestroyOCX();
        }
    }

    //获取公文域位置
    this.getTaggedPosition = function (docdomain) {
        if (this._check()) {
            var ox = this.ax;
            return ox.getTaggedPosition(docdomain);
        }
    }

    //设置打开文档权限
    this.removeAppPermission = function (permission) {
        if (this._check()) {
            var ox = this.ax;
            return ox.removeAppPermission(permission);
        }
    }

    //判断是否正在打印
    this.IsQuietPrinting = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.IsQuietPrinting();
        }
    }

    //判断是否正在签章
    this.IsSigning = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.IsSigning();
        }
    }

    //静默打印设置
    this.printSetting = function () {
        if (this._check()) {
            var ox = this.ax;
            ox.printSetting();
        }
    }

    //本地保存
    this.saveToLocal = function (path) {
        if (this._check()) {
            var ox = this.ax;
            return ox.saveToLocal(path);
        }
    }

    //获取当前页的页码
    this.GetCurPageIndex = function () {
        if (this._check()) {
            var ox = this.ax;
            //return ox.GetCurPageIndex();//htfoxit
            return ox.getCurrentPageNum();//this 2019.10.28 add
        }
    }

    //获取当前文档页数
    this.getPageCount = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.getPageCount();//2019.10.28 same
        }
    }

    //翻页
    this.GotoPage = function (index) {
        if (this._check()) {
            var ox = this.ax;
            //return ox.GotoPage(parseInt(index));//htfoxit
            return ox.gotoPage(parseInt(index));//this 2019.10.28 add
        }
    }

    //打开首页上半部分盖有多个印章的文档
    this.openSignFile = function (url) {
        if (this._check()) {
            var ox = this.ax;
            return ox.openSignFile(url);
        }
    }

    //获取签章个数
    this.CountSignatures = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.CountSignatures();
        }
    }

    //是否有签章
    this.hasSign = function () {
        if (this._check()) {
            var ox = this.ax;
            return ox.hasSign();
        }
    }

    //PDF导出OFD
    //[in]url:导出后ofd文件的目标位置,可以是本地文件，如“D：/files/xxxxx.ofd”；也可以是远程文件，如“http://localhost:8080/exm/Test1”。
    //[in]dpi:图像分辨率，默认96，范围[96,1200]
    //[out]导出成功返回true，失败返回false
    this.pdf2ofd = function (url, dpi) {
        if (this._check()) {
            var ox = this.ax;
            return ox.pdf2ofd(url, dpi);
        }
    }
//以上接口only htfoxit
};

/**
 * 快速加载并初始化OCX控件,返回OCX实例
 *
 * @param div
 *            div的id,ocx放置于此div内.如果为null,则自动创建一个div并追加于body的最后
 * @param width
 *            宽度,如果为null或auto,则设置为100%,也可以设置为具体像素(如500px)
 * @param width
 *            高度,如果为null或auto,则设置为100%,也可以设置为具体像素(如500px)
 * @param downURL
 *            控件安装程序的下载地址,只有在检查到控件未安装时才有用.若未设置,则不会出现下载地址.
 */
OFD.OCX.init = function (div, width, height, downURL) {
    var config = {};
    var tmp = arguments.callee.toString().match(/\(.*?\)/)[0];
    var names = tmp.replace(/[()\s]/g, '').split(',');
    var array = Array.prototype.slice.call(arguments, 0);
    OFD._each(array, function (i, e) {
        if (OFD._isValid(e)) {
            if (OFD._isPlainObject(e)) {
                OFD._extend(e, config);
            } else {
                config[names[i]] = e;
            }
        }
    });
    var ocx = new OFD.OCX(config);
    ocx.load();
    return ocx;
};

//加载并初始化阅读器OCX控件--application/xReader-ofd
init = function (divID, width, height) {
    return OFD.OCX.init(divID, width, height);
};
