var httpURL = 'http://127.0.0.1:63343';

var IEVersion = (function () {
    var userAgent = navigator.userAgent; //取得浏览器的userAgent字符串
    var isIE = userAgent.indexOf("compatible") > -1 && userAgent.indexOf("MSIE") > -1; //判断是否IE<11浏览器
    var isEdge = userAgent.indexOf("Edge") > -1 && !isIE; //判断是否IE的Edge浏览器
    var isIE11 = userAgent.indexOf('Trident') > -1 && userAgent.indexOf("rv:11.0") > -1;
    if (isIE) {
        var reIE = new RegExp("MSIE (\\d+\\.\\d+);");
        reIE.test(userAgent);
        var fIEVersion = parseFloat(RegExp["$1"]);
        if (fIEVersion === 7) {
            return 7;
        } else if (fIEVersion === 8) {
            return 8;
        } else if (fIEVersion === 9) {
            return 9;
        } else if (fIEVersion === 10) {
            return 10;
        } else {
            return 6; //IE版本<=7
        }
    } else if (isEdge) {
        return 20; //edge
    } else if (isIE11) {
        return 11; //IE11
    } else {
        return 30; //不是ie浏览器
    }
})();


// 兼容IE早期版本，建立一个XMLHttpRequest对象
function createXHR() {
    if (typeof XMLHttpRequest != "undefined") {
        return new XMLHttpRequest();
    } else if (typeof ActiveXObject != "undefined") {
        console.log("ActiveX")
        var versions = ["MSXML2.XMLHttp.6.0", "MSXML2.XMLHttp.3.0",
                "MSXML2.XMLHttp"],
            i, len;

        for (i = 0, len = versions.length; i < len; i++) {
            try {
                return new ActiveXObject(versions[i]);
            } catch (ex) {
                //可放入提示文字
            }
        }
        // return new ActiveXObject(arguments.callee.activeXString);
    } else {
        // 没有XHR对象可用，抛出错误
        throw new Error("No XHR object available.");
    }
}
//启动本地程序
function StartAppliction(visible) {
    //yozoOfdReader
    var src = "yozoOfdReader://start=RelayHttpServer&readervisible=" + !!visible //是否启动界面
    var iframe = document.getElementById("ofdIframe");
    if (iframe) {
        iframe.parentNode.removeChild(iframe);
        iframe = null;
    }
    try {
        iframe = document.createElement('<iframe name="ifr"></iframe>');
    } catch (e) {
        iframe = document.createElement('iframe');
        iframe.name = 'ifr';
    }
    iframe.id = "ofdIframe"
    iframe.src = src;
    iframe.width = 0;
    iframe.height = 0;
    document.body.appendChild(iframe);
    iframe.style.display = "none"
}

function callbk(func, param){
    if(typeof dlog !== 'undefined') {
        dlog.log("状态码：" + param.status + "   信息：" + param.message + "   响应内容：" + param.responseText)
    }
    responseMsg = param.responseText;
    if(typeof func == 'function'){
        func(param);
        // dlog.log(param);
    }
}

/**
 * 用于记录接口返回的信息
 * @param {String} text
 */
var responseMsg = "";
function responseText(){
    return responseMsg;
}

/**
 * 主入口
 * @param option 主要包含json数据和回调函数
 */
var finished = true //判断前一个请求是否完成
var optQueue = []; //请求队列----------------------------后续补充
var isAppStart = false; //应用程序是否启动
function invoke(option){
    if(!finished){
        optQueue.push(option);
        return;
    }
    //请求队列
    setInterval(function (){
        if(optQueue.length > 0 && finished){
            invoke(optQueue.shift())//出队列
        }
    }, 500)
    finished = false;
    var req = createXHR();//创建xhr连接
    doInvode(option.tryCount);

    function doInvode(tryCount){
        if(tryCount <= 0){
            finished = true;
            return;
        }
        if(IEVersion > 8) {//解决ie6无法编译过去
            req.onload = function () {
                callbk(option.callback, {
                    status: req.status,
                    message: "成功",
                    responseText: JSON.stringify(req.responseText)
                })
                if (typeof dlog !== 'undefined') {
                    dlog.log("----------------请求结束------------------")
                }
                finished = true;
                // isAppStart = false;//2024.3.13 mlj add 调用接口后，再次调用接口是否重启软件（重启后软件会置顶，但是会出现加载略慢的情况）
            }
            //
            req.onerror = function () {
                callbk(option.callback, {
                    status: req.status,
                    message: "请求失败, 并重新请求"
                })
                // if(tryCount === option.tryCount){
                //     StartAppliction(true);
                // }
                setTimeout(function () {
                    doInvode(tryCount - 1);
                }, option.waitTime)
                // finished = true;
                isAppStart = false;
                // waitTime = waitTime + 500;
            }
            req.ontimeout = function () {
                alert("请求超时，待应用程序打开后重试")
                if (typeof dlog !== 'undefined') {
                    dlog.log("请求超时，待应用程序打开后重试")
                }
                finished = true;
                StartAppliction(true);
            }
        }
        //判断当前状态
        function readyStateChange () {

            if (req.readyState === 4) {
                if (req.status === 200) {
                    callbk(option.callback, {
                        status: req.status,
                        message: "成功",
                        responseText: JSON.stringify(req.responseText)
                    })
                    if (typeof dlog !== 'undefined') {
                        dlog.log("----------------请求结束------------------")
                    }
                    finished = true;
                } else {
                    callbk(option.callback, {
                        status: req.status,
                        message: "请求失败, 并重新请求"
                    })
                    setTimeout(function () {
                        doInvode(tryCount - 1);
                    }, option.waitTime)

                }
            }else{
                return null;
            }
        }

        try{
            if(!isAppStart){
                if(typeof dlog !== 'undefined') {
                    dlog.log("----------------启动程序-----------------")
                }
                StartAppliction(true);
                isAppStart = true;
                // document.getElementById("link").click()
                setTimeout(function (){
                    req.open('POST', httpURL);
                    if(IEVersion <= 8){
                        req.onreadystatechange = readyStateChange;
                    }
                    // req.setRequestHeader("Cache-Control", "no-cache");
                    // req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
                    if(IEVersion > 6) {//ie6报错
                        req.timeout = option.timeout;//超时设置
                    }
                    if(typeof dlog !== 'undefined') {
                        dlog.log("-------------------数据传输中----------------")
                    }
                    // console.log("sending-------------"+ req.readyState)
                    console.log("sendMsg:" + option.msg)
                    req.send(option.msg);
                }, option.connectTime)
            }else{
                req.open('POST', httpURL);
                if(IEVersion <= 8){
                    req.onreadystatechange = readyStateChange;
                }
                if(typeof dlog !== 'undefined') {
                    dlog.log("-------------------数据传输中----------------")
                }
                if(IEVersion > 6) {
                    req.timeout = option.timeout;//超时设置
                }
                // console.log("sending=============" + req.readyState)
                req.send(option.msg);
            }
        }catch(e){

        }

    }

}

