// class JOFDreader{
/**
 * 打开指定的本地或远程OFD或PDF文件。
 *
 * @returns {Promise<unknown>}
 * @param fileName
 * @param onlyRead
 * @param strSaveUrl
 */
openFile = function (fileName, onlyRead, strSaveUrl) {
    var paramNum = arguments.length;
    switch (paramNum){
        case 1:
            return doPromise({
                "openFile": {
                    "openFile": fileName
                }
            })
        case 2:
            return doPromise({
                "openFile": {
                    "openFile": fileName,
                    "onlyRead": onlyRead
                }
            })
        case 3:
            return doPromise({
                "openFile": {
                    "openFile": fileName,
                    "onlyRead": onlyRead,
                    "strSaveUrl": strSaveUrl
                }
            })
    }
};


/**
 * 关闭当前文件
 * @returns
 */
closeFile = function () {
    return doPromise({
        "closeFile": {}
    })
};
/**
 * 设置组件隐藏显示
 * @param {string} compName   组件名称
 * @param {boolean} bVisible   是否显示
 * @returns {Promise<unknown>}
 */
setCompositeVisible = function (compName, bVisible) {
    return doPromise({
        "setCompositeVisible":{
            "compName": compName,
            "bVisible": bVisible
        }
    })
};
/**
 * 保存文件
 * @param {String} strURL（选填）    保存文件路径
 * @returns {Promise<unknown>}
 */
saveFile = function (strURL){
    var paramNum = arguments.length;
    switch (paramNum) {
        case 0:
            return doPromise({
                "saveFile":{}
            })
        case 1:
            return doPromise({
                "saveFile":{
                    "strURL": strURL
                }
            })
    }
};
/**
 *  打印
 * @param {String} strURL
 * @param {boolean} bGray
 * @returns {Promise<unknown>}
 */
printFile = function (strURL, bGray){
    return doPromise({
        "printFile":{
            "strURL": strURL,
            "bGray": bGray
        }
    })
};
/**
 * 获取版本号
 * @returns {Promise<unknown>}
 */
version = function (){
    return doPromise({
        "getPluginVersion":{}
    })

};
/**
 * ofd文件中是否存在签章
 * @returns {Promise<unknown>}
 */
hasSign = function (){
    return doPromise({
        "hasSign":{}
    })
};
/**
 * 另存为
 * @param {boolean} bOpen
 * @returns {Promise<unknown>}
 */
saveAs = function (){
    return doPromise({
        "saveAs":{}
    })
}

/**
 * 获取日志路径
 * @returns {Promise<unknown>}
 */
getLogFilePath = function (){
    return doPromise({
        "getLogFilePath":{}
    })
}

/**
 * 添加水印
 * @param {String} xmlParam
 * @returns {Promise<unknown>}
 */
addTrackInfo = function (xmlParam){
    return doPromise({
        "addTrackInfo":{
            "xmlParam":xmlParam
        }
    })
}
/**
 * 清除水印
 * @returns {Promise<unknown>}
 */
clearTrackInfo = function (){
    return doPromise({
        "clearTrackInfo":{}
    })
}

getUserName = function (){
    return doPromise({
        "getUserName":{}
    })
}

/**
 *  设置用户名
 * @param  {String} userName
 * @returns {Promise<unknown>}
 */
setUserName = function (userName){
    return doPromise({
        "setUserName":{
            "userName":userName
        }
    })
}
setMetaData = function (id, value){
    return doPromise({
        "setMetaData":{
            "id":id,
            "value":value
        }
    })
}
getMetaData = function (id){
    return doPromise({
        "getMetaData":{
            "id":id
        }
    })
}
setZoomRadio = function (zoomFactor){
    return doPromise({
        "setZoomRadio":{
            "zoomFactor":zoomFactor
        }
    })

}
getZoomRadio = function (){
    return doPromise({
        "getZoomRadio":{}
    })
}
about = function (){
    return doPromise({
        "about":{}
    })
}
closeAllFiles = function (){
    return doPromise({
        "closeAllFiles":{}
    })
}
selectAll = function (){
    return doPromise({
        "selectAll":{}
    })
}

zoomIn = function (){
    return doPromise({
        "zoomIn":{}
    })
}
zoomOut = function(){
    return doPromise({
        "zoomOut":{}
    })
}
getPageCount = function (){
    return doPromise({
        "getPageCount":{}
    })
}
getCurrentPageNum = function(){
    return doPromise({
        "getCurrentPageNum":{}
    })
}
gotoFirstPage = function (){
    return doPromise({
        "gotoFirstPage":{}
    })
}
gotoLastPage = function (){
    return doPromise({
        "gotoLastPage":{}
    })
}
gotoPrevPage = function (){
    return doPromise({
        "gotoPrevPage":{}
    })
}
gotoNextPage = function (){
    return doPromise({
        "gotoNextPage":{}
    })
}
setViewPreference = function (key, value){
    return doPromise({
        "setViewPreference":{
            "key": "navigator",
            "value": value
        }
    })
}
setSealId = function (id){
    return doPromise({
        "setSealId":{
            "id": id
        }
    })
}
sealDlg = function (){
    return doPromise({
        "sealDlg":{}
    })
}
pdf2ofd = function (url, dpi){
    return doPromise({
        "pdf2ofd":{
            "url": url,
            "dpi": dpi
        }
    })
}

//print为关键字   该接口会启动浏览器打印窗口
printDlg = function (){
    return doPromise({
        "print":{}
    })
}
fitWidth = function (){
    return doPromise({
        "fitWidth":{}
    })
}
fitPage = function (){
    return doPromise({
        "fitPage":{}
    })
}
fitHeight = function (){
    return doPromise({
        "fitHeight":{}
    })
}
zoomReset = function (){
    return doPromise({
        "zoomReset":{}
    })
}
gotoPage = function (pageNum){
    return doPromise({
        "gotoPage":{
            "pageNum":pageNum
        }
    })
}
onOffNavBar = function (state){
    return doPromise({
        "onOffNavBar":{
            "state":state
        }
    })
}
navBarShowed = function (){
    return doPromise({
        "navBarShowed":{}
    })
}
onOffToolBar = function (state){
    return doPromise({
        "onOffToolBar":{
            "state":state
        }
    })
}
isToolBarShowed = function(){
    return doPromise({
        "isToolBarShowed":{}
    })
}
onOffFileTool = function (state){
    return doPromise({
        "onOffFileTool":{
            "state":state
        }
    })
}
isFileToolShowed = function (){
    return doPromise({
        "isFileToolShowed":{}
    })
}
onOffZoomTool = function (state){
    return doPromise({
        "onOffZoomTool":{
            "state":state
        }
    })
}
isZoomToolShowed = function (){
    return doPromise({
        "isZoomToolShowed":{}
    })
}
onOffZoomModeTool = function (state){
    return doPromise({
        "onOffZoomModeTool":{
            "state":state
        }
    })
}
isZoomModeShowed = function (){
    return doPromise({
        "isZoomModeShowed":{}
    })
}

onOffPageTool = function (state){
    return doPromise({
        "onOffPageTool":{
            "state":state
        }
    })
}
isPageToolShowed = function (){
    return doPromise({
        "isPageToolShowed":{}
    })
}
onOffSelectTool = function (state){
    return doPromise({
        "onOffSelectTool":{
            "state":state
        }
    })
}
isSelectToolShowed = function (){
    return doPromise({
        "isSelectToolShowed":{}
    })
}
onOffSearchTool = function(state){
    return doPromise({
        "onOffSearchTool":{
            "state":state
        }
    })
}
isSearchToolShowed = function(){
    return doPromise({
        "isSearchToolShowed":{}
    })
}
onOffSignAndWaterMrksTool = function(state){
    return doPromise({
        "onOffSignAndWaterMrksTool":{
            "state":state
        }
    })
}
isSignAndWaterMrksToolShowed = function(){
    return doPromise({
        "isSignAndWaterMrksToolShowed":{}
    })
}
onOffAnnoTool = function(state){
    return doPromise({
        "onOffAnnoTool":{
            "state":state
        }
    })
}
isAnnoToolShowed = function(){
    return doPromise({
        "isAnnoToolShowed":{}
    })
}
setCompositeEnable = function(compName, isEnable){
    return doPromise({
        "setCompositeEnable":{
            "compName":compName,
            "isEnable":isEnable
        }
    })
}
setLogSvrURL = function(url){
    return doPromise({
        "setLogSvrURL":{
            "url":url
        }
    })
}
getTaggedText = function(tagId){
    return doPromise({
        "getTaggedText":{
            "tagId":tagId
        }
    })
}
openSealDlg = function(){
    return doPromise({
        "sealDlg":{}
    })
}
onOffRightClick = function(bHide){
    return doPromise({
        "onOffRightClick":{
            "bHide":bHide
        }
    })
};

addWaterMakerAnnot = function (xmlParam){
    return doPromise({
        "addTrackInfo":{
            "xmlParam":xmlParam
        }
    })
}


//-------------------------------暂未调整接口（不能使用）-----------------------------------------------
//2024.1.3 mlj add:新增接口，统一jsapi与插件接口
//静默打印
quietPrintFile = function (title, color, isquietprint){
    return doPromise({
        "quietPrintFile":{
            "title":title,
            "color":color,
            "PrintFile":isquietprint
        }
    })
}
//打印Dlg
openPrintDlg = function (){
    return doPromise({
        "print":{}
    })
}

printSet = function (printParam){
    return doPromise({
        "configPrintOptions":{
            "printParam":printParam
        }
    })
}
// 设置印章名称
setSealName = function (path){
    return doPromise({
        "setSealName":{
            "path":path
        }
    })
}
//设置签名算法
/*setSealSignMethod = function (path){
    return doPromise({
        "setSealSignMethod":{
            "path":path
        }
    })
}*/

setLogURL = function (strurl, oid){
    return doPromise({
        "setLogURL":{
            "strurl":strurl,
            "oid":oid
        }
    })
}

/*HidePanels = function (nHide){
    return doPromise({
        "HidePanels":{
            "nHide":nHide,
        }
    })
}*/

setPrintInfo = function (num){
    return doPromise({
        "setPrintInfo":{
            "num":num
        }
    })
}
//设置阅读模式
setDisPlayMode = function (disPlayMode){
    return doPromise({
        "setDisPlayMode":{
            "disPlayMode":disPlayMode
        }
    })
}
//获取公文域位置
getTaggedPosition = function (docdomain){
    return doPromise({
        "getTaggedPosition":{
            "docdomain":docdomain
        }
    })
}
//设置打开文档权限
removeAppPermission = function (permission){
    return doPromise({
        "removeAppPermission":{
            "permission":permission
        }
    })
}
//判断是否正在打印
IsQuietPrinting = function (){
    return doPromise({
        "IsQuietPrinting":{
        }
    })
}
//判断是否正在签章
IsSigning = function (){
    return doPromise({
        "IsSigning":{
        }
    })
}
//静默打印设置
printSetting = function (){
    return doPromise({
        "printSetting":{
        }
    })
}
//本地保存
saveToLocal = function (path){
    return doPromise({
        "saveToLocal":{
            "path":path
        }
    })
}
//获取当前页的页码
GetCurPageIndex = function (){
    return doPromise({
        "GetCurPageIndex":{
        }
    })
}
//打开首页上半部分盖有多个印章的文档
openSignFile = function (url){
    return doPromise({
        "openSignFile":{
            "url":url
        }
    })
}
//获取签章个数
CountSignatures = function (){
    return doPromise({
        "CountSignatures":{
        }
    })
}
//功能描述:pdf文件转成ofd文件
//[in] pszPdfUrl    pdf的url或本地全路径；
//[in] pszOfdUrl    ofd的url或本地全路径；
//[in] nBegin       固定传0
//[in] nEnd         固定传0
//[in] nResolution  pdf转ofd的分辨率，比如96、150、300等
//[in] nResv        固定传0
//[返回值] 配置信息的值
//[返回值] 配置信息的值
convertPdfToOfd = function (pszPdfUrl, PszOfdUrl, nBegin, nEnd, nResolution, nResv){
    return doPromise({
        "convertPdfToOfd":{
            "pszPdfUrl":pszPdfUrl,
            "PszOfdUrl":PszOfdUrl,
            "nBegin":nBegin,
            "nEnd":nEnd,
            "nResolution":nResolution,
            "nResv":nResv
        }
    })
}
//根据可配置参数执行模拟点击操作   注：该接口中可以是无参，也可以传入一个参数，也可以传入两个参数
//[in]  commandId
//[in]  params
//[返回值] True/False
performClick = function (a, b){
    var paramNum = arguments.length;
    console.log(paramNum)
    switch (paramNum){
        case 0:
            return doPromise({
                "performClick":{
                }
            })
        case 1:
            return doPromise({
                "performClick":{
                    "a":a
                }
            })
        case 2:
            return doPromise({
                "performClick":{
                    "a":a,
                    "b":b
                }
            })
    }
}
//设计签批笔触样式
//[in] tabletFullsign
//[返回值] 0
setConfigInfo = function (configName, configValue){
    return doPromise({
        "setConfigInfo":{
            "configName":configName,
            "configValue":configValue
        }
    })
}
//设置签批笔记粗细
//[in]  size
//[返回值] true/false
setSignSize = function (size){
    return doPromise({
        "setSignSize":{
            "size":size
        }
    })
}
//设置常用签批图片
//[in]  strJson
//[返回值] 无
setCommonSigns = function (strJson){
    return doPromise({
        "setCommonSigns":{
            "strJson":strJson
        }
    })
}
//通过接口直接插入文本
//[in]  strJson
//[返回值] json
addFreeText = function (strJson){
    return doPromise({
        "addFreeText":{
            "strJson":strJson
        }
    })
}
//设置文本批注默认字体
//[in]  strJson
//[返回值] 0
setFreeTextDefaultFont = function (strJson){
    return doPromise({
        "setFreeTextDefaultFont":{
            "strJson":strJson
        }
    })
}
//获取文本信息
//[in]  id
//[返回值] json
getFreeTextContentById = function (id){
    return doPromise({
        "getFreeTextContentById":{
            "id":id
        }
    })
}
//设置鼠标开关
//[in]  bSwitch
//[返回值] 无
AnnotaTextTitleSwitch = function (bSwitch){
    return doPromise({
        "AnnotaTextTitleSwitch":{
            "bSwitch":bSwitch
        }
    })
}

//2024.3.13 mlj add 补充接口与np插件保持一致
/**
 * 通过文本框插入文本时，设置文本框上侧的字体设置栏中的常用语选择框。
 * @param strjson {string} 常用语。通过json字符串数组的形式插入，当json数组设置为空数组时，常用语选择栏置空不显示，只有设置了常用语才显示该项。
 * @returns {Promise<unknown>}
 */
SetFreqUserdComments = function (strjson){
    return doPromise({
        "SetFreqUserdComments":{
            "strjson":strjson
        }
    })
}
/**
 * 设置签名功能为图章时的图片，在设置登录时，根据登录人员不同级别设置，无图章签名的可以不设置。
 * @param strjson {string} 签名图片json字符串。
 * @returns {Promise<unknown>}
 */
SetSignatureImageByJson = function (strjson){
    return doPromise({
        "SetSignatureImageByJson":{
            "strjson":strjson
        }
    })
}
/**
 * 设置鼠标悬停在文本框上方时的提示信息。
 * @param strjson {string} 文本提示信息Json字符串。
 * @returns {Promise<unknown>}
 */
SetAnnotaTextTitle = function (strjson){
    return doPromise({
        "SetAnnotaTextTitle":{
            "strjson":strjson
        }
    })
}
/**
 * 设置时间戳格式。
 * @param startTime {string} 描述时间戳格式以及其字体信息的Json字符串。
 * @returns {Promise<unknown>}
 */
setTimeFormat = function (startTime){
    return doPromise({
        "setTimeFormat":{
            "startTime":startTime
        }
    })
}





//-------------------------------暂未调整接口（不能使用）-----------------------------------------------












//============================================================================

var doPromise = function (param) {
    return new Promise(function (resolve) {
        sendMsg(
            param
            , function (data) {
                resolve(data)
            })
    })
};


function sendMsg(reqMsg, callback) {
    if(typeof dlog !== 'undefined') {
        dlog.log("=================================================")
    }
    var info = {};
    info.funcs = analysisMsg(reqMsg);

    var option = {};
    var data = {
        "name": "xreader",
        "function": "none", //预留 暂无实际用途
        "info": info   //数据信息
    }
    var strData = JSON.stringify(data);
    if(typeof dlog !== 'undefined') {
        dlog.log("准备传输的数据：" + strData);
    }
    /*  if (IEVersion < 10) {
          try {
              console.log("===========")
              eval("strData = '" + JSON.stringify(data) + "';");
              // dlog.log('ieVersion < 10:', strData)
          } catch (err) {

          }
      }*/
    option.msg = "yozoOFD://" + strData;  //传输数据
    option.timeout = sendOption.timeout;  //超时时间
    option.tryCount = sendOption.tryCount;   //请求失败后尝试次数
    option.waitTime = sendOption.waitTime; //请求失败，重传等待时间
    option.connectTime = sendOption.connectTime;   //等待程序启动时间
    option.callback = callback;

    // dlog.log("处理后的option对象" + JSON.stringify(option));
    invoke(option);

}

function analysisMsg(requestParam) {
    funcs_convert = [];
    for (var j in requestParam) {
        var i = 1;
        interface_param = {};
        param_convert = {};
        for (var interface_key in requestParam[j]) {
            // console.log(requestParam[j][interface_key].toString())
            param_convert["param" + i] = (requestParam[j][interface_key]).toString();//将参数修改为string类型，后面加tostring即可
            i++;
        }
        interface_param[j] = param_convert;
        funcs_convert.push(interface_param);
    }
    // console.log(funcs_convert)
    return funcs_convert;
}


/* 为兼容低版本es5   取消类结构 全部使用函数调用
var jofdreader1 = new JOFDreader();
var unit = new UnitTest();
*/
